Automatic layout in EJ2 JavaScript Diagram control

12 Jul 202324 minutes to read

Diagram provides support to auto-arrange the nodes in the diagram area that is referred as Layout. It includes the following layout modes:

Layout modes

  • Hierarchical layout
  • Organization chart
  • Radial tree
  • Symmetric layout
  • Mind Map layout
  • Complex hierarchical tree layout

Hierarchical layout

The hierarchical tree layout arranges nodes in a tree-like structure, where the nodes in the hierarchical layout may have multiple parents. There is no need to specify the layout root. To arrange the nodes in a hierarchical structure, specify the layout type as hierarchical tree. The following example shows how to arrange the nodes in a hierarchical structure.

Note: If you want to use hierarchical tree layout in diagram, you need to inject HierarchicalTree in the diagram.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var data = [{
        Name: "Steve-Ceo"
    },
    {
        Name: "Kevin-Manager",
        ReportingPerson: "Steve-Ceo"
    },
    {
        Name: "Peter-Manager",
        ReportingPerson: "Steve-Ceo"
    },
    {
        Name: "John- Manager",
        ReportingPerson: "Peter-Manager"
    },
    {
        Name: "Mary-CSE ",
        ReportingPerson: "Peter-Manager"
    },
    {
        Name: "Jim-CSE ",
        ReportingPerson: "Kevin-Manager"
    },
    {
        Name: "Martin-CSE",
        ReportingPerson: "Kevin-Manager"
    }
];

var items = new ej.data.DataManager(data, new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '650px',
    //Uses layout to auto-arrange nodes on the diagram page
    layout: {
        //Sets layout type
        type: 'HierarchicalTree'
    },//Configures data source for diagram
    dataSourceSettings: {
        id: 'Name',
        parentId: 'ReportingPerson',
        dataManager: items
    },//Sets the default properties for nodes
    getNodeDefaults: (obj) => {
        obj.shape = {
            type: 'Text',
            content: (obj.data.Name)
        };
        obj.style = {
            fill: 'None',
            strokeColor: 'none',
            strokeWidth: 2,
            bold: true,
            color: 'white'
        };
        obj.borderColor = 'white';
        obj.width = 100;
        obj.height = 40;
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        (obj.shape ).margin = {
            left: 5,
            right: 5,
            top: 5,
            bottom: 5
        };
        return obj;
    },//Sets the default properties for and connectors
    getConnectorDefaults: (connector, diagram) => {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        connector.targetDecorator.style.fill  =  '#6BA5D7';
        connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
        connector.type = 'Orthogonal';
        return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Radial tree layout

The radial tree layout arranges nodes on a virtual concentric circle around a root node. Sub-trees formed by the branching of child nodes are located radially around the child nodes. This arrangement result in an ever-expanding concentric arrangement with radial proximity to the root node indicating the node level in the hierarchy. The layout root property can be used to define the root node of the layout. When no root node is set, the algorithm automatically considers one of the diagram nodes as the root node.

To arrange nodes in a radial tree structure, set the type of the layout as RadialTree. The following code illustrates how to arrange the nodes in a radial tree structure.

Note: If you want to use radial tree layout in diagram, you need to inject DataBinding and RadialTree in the diagram.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var data = [
        {
            "Id": "parent", "Name": "Maria Anders", "Designation": "Managing Director",
            "ImageUrl": "../content/images/radialtree/Clayton.png", "IsExpand": "true", "RatingColor": "#C34444"
        },
        {
            "Id": 1, "Name": "Ana Trujillo", "Designation": "Project Manager",
            "ImageUrl": "../content/images/radialtree/Thomas.PNG", "IsExpand": "false",
            "RatingColor": "#68C2DE", "ReportingPerson": "parent"
        },
        {
            "Id": 2, "Name": "Lino Rodri", "Designation": "Project Manager",
            "ImageUrl": "../content/images/radialtree/Robin.PNG", "IsExpand": "true",
            "RatingColor": "#68C2DE", "ReportingPerson":  "parent"
        },
        {
            "Id": 3, "Name": "Philip Cramer", "Designation": "Project Manager",
            "ImageUrl": "../content/images/radialtree/Robin.PNG", "IsExpand": "true",
            "RatingColor": "#68C2DE", "ReportingPerson":  "parent"
        },
        {
            "Id": 4, "Name": "Pedro Afonso", "Designation": "Project Manager",
            "ImageUrl": "../content/images/radialtree/Paul.png", "IsExpand": "true",
            "RatingColor": "#68C2DE", "ReportingPerson":  1
        },
        {
            "Id": 5, "Name": "Anto Moreno", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/image53.png", "IsExpand": "false",
            "RatingColor": "#93B85A", "ReportingPerson": 1
        },
        {
            "Id": 6, "Name": "Elizabeth Roel", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Maria.png", "IsExpand": "false",
            "RatingColor": "#93B85A", "ReportingPerson": 2
        },
        {
            "Id": 7, "Name": "Aria Cruz", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Jenny.png", "IsExpand": "false",
            "RatingColor": "#93B85A", "ReportingPerson": 3  
        },
        {
            "Id": 8, "Name": "Eduardo Roel", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/image55.png", "IsExpand": "true",
            "RatingColor": "#93B85A", "ReportingPerson": 1
        },
        {
            "Id": 9, "Name": "Howard Snyd", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Jenny.png", "IsExpand": "false",
            "RatingColor": "#68C2DE", "ReportingPerson": 1
        },
        {
            "Id": 10, "Name": "Daniel Tonini", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Thomas.png", "IsExpand": "true",
            "RatingColor": "#93B85A", "ReportingPerson": 1
        },
        {
            "Id": 11, "Name": "Nardo Batista", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Maria.PNG", "IsExpand": "true",
            "RatingColor": "#68C2DE", "ReportingPerson": 1
        },
        {
            "Id": 12, "Name": "Michael Holz", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Thomas.PNG", "IsExpand": "true",
            "RatingColor": "#68C2DE", "ReportingPerson": 1
        },
        {
            "Id": 13, "Name": "Kloss Perrier", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Clayton.png", "IsExpand": "None",
            "RatingColor": "#93B85A", "ReportingPerson": 1
        },
        {
            "Id": 14, "Name": "Liz Nixon", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Jenny.png", "IsExpand": "false",
            "RatingColor": "#68C2DE", "ReportingPerson": 1
        },
        {
            "Id": 15, "Name": "Paul Henriot", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Thomas.png", "IsExpand": "false",
            "RatingColor": "#D46E89", "ReportingPerson": 1
        },
        {
            "Id": 16, "Name": "Paula Parente", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/John.png", "IsExpand": "None",
            "RatingColor": "#EBB92E", "ReportingPerson": 1
        },
        {
            "Id": 17, "Name": "Matti Kenna", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Jenny.png", "IsExpand": "None",
            "RatingColor": "#93B85A", "ReportingPerson": 3
        },
        {
            "Id": 18, "Name": "Laura Callahan", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Robin.png", "IsExpand": "false",
            "RatingColor": "#D46E89", "ReportingPerson": 3
        },
        {
            "Id": 19, "Name": "Simon Roel", "Designation": "Project Lead",
            "ImageUrl": "../content/images/radialtree/Clayton.png", "IsExpand": "true",
            "RatingColor": "#93B85A", "ReportingPerson": 3
        },
        {
            "Id": 20, "Name": "Thomas Hardy", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/image57.png", "IsExpand": "false",
            "RatingColor": "#68C2DE", "ReportingPerson": 3
        },
        {
            "Id": 21, "Name": "Martín Kloss", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/Robin.png", "IsExpand": "false",
            "RatingColor": "#93B85A", "ReportingPerson": 3
        },
        {
            "Id": 22, "Name": "Maria Larsson", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/image51.png", "IsExpand": "false",
            "RatingColor": "#EBB92E", "ReportingPerson": 3
        },
        {
            "Id": 23, "Name": "Diego Roel", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/image55.png", "IsExpand": "false",
            "RatingColor": "#D46E89", "ReportingPerson": 3
        },
        {
            "Id": 24, "Name": "José Pedro ", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/Thomas.png", "IsExpand": "true",
            "RatingColor": "#D46E89", "ReportingPerson": 3
        },
        {
            "Id": 25, "Name": "Manu Pereira", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/image56.png", "IsExpand": "None",
            "RatingColor": "#D46E89", "ReportingPerson": 3
        },
        {
            "Id": 26, "Name": "Annette Roel", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/image55.png", "IsExpand": "false",
            "RatingColor": "#93B85A", "ReportingPerson": 2
        },
        {
            "Id": 27, "Name": "Catherine Kaff", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/image57.png", "IsExpand": "false",
            "RatingColor": "#93B85A", "ReportingPerson": 2
        },
        {
            "Id": 28, "Name": "Lúcia Carvalho", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/Robin.PNG", "IsExpand": "false",
            "RatingColor": "#93B85A", "ReportingPerson": 2
        },
        {
            "Id": 29, "Name": "Alej Camino", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/Thomas.PNG", "IsExpand": "false",
            "RatingColor": "#93B85A", "ReportingPerson": 2
        },
        {
            "Id": 30, "Name": "Liu Wong", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/image57.png", "IsExpand": "None",
            "RatingColor": "#D46E89", "ReportingPerson": 2
        },
        {
            "Id": 31, "Name": "Karin Josephs", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/image55.png", "IsExpand": "None",
            "RatingColor": "#D46E89", "ReportingPerson": 2
        },
        {
            "Id": 32, "Name": "Ruby Anabela ", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/Thomas.png", "IsExpand": "None",
            "RatingColor": "#D46E89", "ReportingPerson": 2
        },
        {
            "Id": 33, "Name": "Pirkko King", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/Robin.png", "IsExpand": "None",
            "RatingColor": "#D46E89", "ReportingPerson": 2
        },
        {
            "Id": 34, "Name": "Karl Jablonski", "Designation": "Senior S/w Engg",
            "ImageUrl": "../content/images/radialtree/image53.png", "IsExpand": "None",
            "RatingColor": "#D46E89", "ReportingPerson": 2
        },
        
    ];

var items = new ej.data.DataManager(data , new ej.data.Query().take(5));

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '590px',
    snapSettings: { constraints: 0 },
    layout: {
        type: 'RadialTree', horizontalSpacing: 30, verticalSpacing: 30, root: 'parent'
    },
    dataSourceSettings: {
        id: 'Id', parentId: 'ReportingPerson', dataManager: items
    },

    getNodeDefaults: (obj, diagram) => {
        obj.height = 15;
        obj.width = 15;
        obj.backgroundColor = 'lightgrey';
        obj.style = { fill: 'transparent', strokeWidth: 2 };
        return obj;
    }, getConnectorDefaults: (connector, diagram) => {
        connector.targetDecorator.shape = 'None';
        connector.type = 'Straight';
        return connector;
    },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Organizational Chart

An organizational chart is a diagram that displays the structure of an organization and relationships. To create an organizational chart, the type of layout should be set as an OrganizationalChart.

The following code example illustrates how to create an organizational chart.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
    var data = [
        { Id: "parent", Role: "Project Management" },
        { Id: 1, Role: "R&D Team", Team: "parent" },
        { Id: 3, Role: "Philosophy", Team: "1" },
        { Id: 4, Role: "Organization", Team: "1" },
        { Id: 5, Role: "Technology", Team: "1" },
        { Id: 7, Role: "Funding", Team: "1" },
        { Id: 8, Role: "Resource Allocation", Team: "1" },
        { Id: 9, Role: "Targeting", Team: "1" },
        { Id: 11, Role: "Evaluation", Team: "1" },
        { Id: 156, Role: "HR Team", Team: "parent" },
        { Id: 13, Role: "Recruitment", Team: "156" },
        { Id: 113, Role: "Training", Team: "12" },
        { Id: 112, Role: "Employee Relation", Team: "156" },
        { Id: 14, Role: "Record Keeping", Team: "12" },
        { Id: 15, Role: "Compensations & Benefits", Team: "12" },
        { Id: 16, Role: "Compliances", Team: "12" },
        { Id: 17, Role: "Production & Sales Team", Team: "parent" },
        { Id: 119, Role: "Design", Team: "17" },
        { Id: 19, Role: "Operation", Team: "17" },
        { Id: 20, Role: "Support", Team: "17" },
        { Id: 21, Role: "Quality Assurance", Team: "17" },
        { Id: 23, Role: "Customer Interaction", Team: "17" },
        { Id: 24, Role: "Support and Maintenance", Team: "17" },
        { Id: 25, Role: "Task Coordination", Team: "17" }
    ];

var items = new ej.data.DataManager(data , new ej.data.Query().take(5));
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '550px',
    layout: { type: 'OrganizationalChart' },
    dataSourceSettings: { id: 'Id', parentId: 'Team', dataManager: items },
    getNodeDefaults: (obj) => {
        obj.shape = { type: 'Text', content: (obj.data).Role };
        obj.style = { fill: 'None', strokeColor: 'none',strokeWidth: 2,bold:true,color:'white' };
        obj.borderColor = 'black';
        obj.backgroundColor = 'darkcyan';
        obj.width = 75;
        obj.height = 40;
        obj.borderWidth = 1;
        (obj.shape).margin = { left: 5, right: 5, top: 5, bottom: 5 };
        return obj;
    }, getConnectorDefaults: (connector, diagram) => {
        connector.type = 'Orthogonal';
        return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Organizational chart layout starts parsing from root and iterate through all its child elements. The getLayoutInfo method provides necessary information of a node’s children and the way to arrange (direction, orientation, offsets, etc.) them. The arrangements can be customized by overriding this function as explained.

GetLayoutInfo
Set chart orientations, chart types, and offset to be left between parent and child nodes by overriding the method, diagram.layout.getLayoutInfo. The getLayoutInfo method is called to configure every subtree of the organizational chart. It takes the following arguments.

* node: Parent node to that options are to be customized.
* options: Object to set the customizable properties.
ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var data = [
    {
        'Id': 'parent', 'Name': 'Maria Anders', 'Designation': 'Managing Director',
        'IsExpand': 'true', 'RatingColor': '#C34444'
    },
    {
        'Id': 1, 'Name': 'Ana Trujillo', 'Designation': 'Project Manager',
        'IsExpand': 'false',
        'RatingColor': '#68C2DE', 'ReportingPerson': 'parent'
    },
    {
        'Id': 2, 'Name': 'Anto Moreno', 'Designation': 'Project Lead',
        'IsExpand': 'false',
        'RatingColor': '#93B85A', 'ReportingPerson': 'parent'
    }
];

var items = new ej.data.DataManager(data , new ej.data.Query().take(7));

diagram = new ej.diagrams.Diagram({
    snapSettings: { constraints: 0 },
    layout: {
        type: 'OrganizationalChart', margin: { top: 20 },
        getLayoutInfo: (node, option) => {
            if (!option.hasSubTree) {
                option.orientation = 'Vertical';
                option.type = 'Alternate';
            }
        }
    },
    dataSourceSettings: {
        id: 'Id', parentId: 'ReportingPerson', dataManager: items
    },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

The following table illustrates the properties that “options” argument takes.

Property Description Default Value
options.assistants By default, the collection is empty. When any of the child nodes have to be set asAssistant, you can remove from children collection and have to insert into assistants collection. Empty array
options.orientation Gets or sets the organizational chart orientation. SubTreeOrientation.Vertical
options.type Gets or sets the chart organizational chart type. For horizontal chart orientation:SubTreeAlignments.Center and for vertical chart orientation:SubTreeAlignments.Alternate
options.offset Offset is the horizontal space to be left between parent and child nodes. 20 pixels applicable only for vertical chart orientations.
options.hasSubTree Gets whether the node contains subtrees. Boolean
options.level Gets the depth of the node from layout root. Number
options.enableRouting By default, connections are routed based on the chart type and orientations. This property gets or sets whether default routing is to be enabled or disabled. true
options.rows Sets the number of rows on which the child nodes will be arranged. Applicable only for balanced type horizontal tree. Number

The following table illustrates the different chart orientations and chart types.

Orientation Type Description Example
Horizontal Left Arranges the child nodes horizontally at the left side of the parent. Horizontal Left
  Right Arranges the child nodes horizontally at the right side of the parent. Horizontal Right
  Center Arranges the children like standard tree layout orientation. Horizontal Center
  Balanced Arranges the leaf level child nodes in multiple rows. Horizontal Balanced
Vertical Left Arranges the children vertically at the left side of the parent. Vertical Left
  Right Arranges the children vertically at the right side of the parent. Vertical Right
  Alternate Arranges the children vertically at both left and right sides of the parent. Vertical Alternate

The following code example illustrates how to set the vertical right arrangement to the leaf level trees.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var data = [{ Id: "parent", Role: "Board" },
	{ Id: "1", Role: "General Manager", Manager: "parent" },
	{ Id: "2", Role: "Human Resource Manager", Manager: "1" },
	{ Id: "3", Role: "Trainers", Manager: "2" },
	{ Id: "4", Role: "Recruiting Team", Manager: "2" },
	{ Id: "5", Role: "Finance Asst. Manager", Manager: "2" },
	{ Id: "6", Role: "Design Manager", Manager: "1" },
	{ Id: "7", Role: "Design Supervisor", Manager: "6" },
	{ Id: "8", Role: "Development Supervisor", Manager: "6" },
	{ Id: "9", Role: "Drafting Supervisor", Manager: "6" },
	{ Id: "10", Role: "Marketing Manager", Manager: "1" },
	{ Id: "11", Role: "Oversea sales Manager", Manager: "10" },
	{ Id: "12", Role: "Petroleum Manager", Manager: "10" },
	{ Id: "13", Role: "Service Dept. Manager", Manager: "10" },
];

var items = new ej.data.DataManager(data, new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '530px',
    snapSettings: { constraints: 0 },
    layout: {
        type: 'OrganizationalChar',
        getLayoutInfo: (node, options) => {
            if (node.data['Role'] === 'General Manager') {
                options.assistants.push(options.children[0]);
                options.children.splice(0, 1);
            }
            if (!options.hasSubTree) {
                options.type = 'Right';
                options.orientation = 'Vertical';
            }
        }
    },
    dataSourceSettings: {
        
        id: 'Id', parentId: 'Manager', dataManager: items
    },

    getNodeDefaults: (obj, diagram) => {
        obj.width = 150;
        obj.height = 50;
        obj.style.fill = 'darkcyan';
        obj.annotations = [{ content: obj.data['Role'], style: { color: 'white' } }];
        return obj;
    }, getConnectorDefaults: (connector, diagram) => {
        connector.targetDecorator.shape = 'None';
        connector.type = 'Orthogonal';
        return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Assistant

Assistants are child item that have a different relationship with the parent node. They are laid out in a dedicated part of the tree. A node can be specified as an assistant of its parent by adding it to the assistants property of the argument “options”.

The following code example illustrates how to add assistants to layout.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var data = [{ Id: 1, Role: "General Manager" },
	{ Id: 2, Role: "Assistant Manager", Team: 1 },
	{ Id: 3, Role: "Human Resource Manager", Team: 1 },
	{ Id: 4, Role: "Design Manager", Team: 1 },
	{ Id: 5, Role: "Operation Manager", Team: 1 },
	{ Id: 6, Role: "Marketing Manager", Team: 1 }
];

var items= new ej.data.DataManager(data, new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '530px',
    snapSettings: { constraints: 0 },
    layout: {
        type: 'OrganizationalChart',
        getLayoutInfo: (node, options) => {
            if (node.data['Role'] === 'General Manager') {
                options.assistants.push(options.children[0]);
                options.children.splice(0, 1);
            }
            if (!options.hasSubTree) {
                options.type = 'Center';
                options.orientation = 'Horizontal';
            }
        }
    },
    dataSourceSettings: {
        id: 'Id', parentId: 'Team', dataManager: items
    },

    getNodeDefaults: (obj, diagram) => {
        obj.width = 150;
        obj.height = 50;
        obj.style.fill = 'darkcyan';
        obj.annotations = [{ content: obj.data['Role'], style: { color: 'white' } }];
        return obj;
    }, getConnectorDefaults: (connector, diagram) => {
        connector.targetDecorator.shape = 'None';
        connector.type = 'Orthogonal';
        return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Symmetric layout

The symmetric layout has been formed using nodes position by closer together or pushing them further apart. This is repeated iteratively until the system comes to an equilibrium state.

The layout’s springLength defined as how long edges should be, ideally. This will be the resting length for the springs. Edge attraction and vertex repulsion forces to be defined by using layout’s springFactor, the more sibling nodes repel each other. The relative positions do not change any more from one iteration to the next. The number of iterations can be specified by using layout’s maxIteration.

The following code illustrates how to arrange the nodes in a radial tree structure.

Note: If you want to use symmetric layout in diagram, you need to inject SymmetricLayout in the diagram.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var nodes = [];
var connectors = [];

function ConnectNodes(parentNode, childNode) {
    var connector = {
        id: parentNode.id + childNode.id,
        sourceID: parentNode.id,
        targetID: childNode.id,
        targetDecorator: { shape: 'None' }
    }
    return connector;
}

function GetRectangle(name) {
    var shape = { type: 'Basic', shape: 'Ellipse' };
    var node = { id: name, height: 25, width: 25, borderColor: '#5e5e5e', borderWidth: 1, style: { fill: '#ff6329' }, shape: shape };
    return node;
}

function populateNodes() {
    var parentRect = GetRectangle("p");
    nodes.push(parentRect);
    for (var i = 0; i < 2; i++) {
        var childRect_i = GetRectangle("c" + i);
        nodes.push(childRect_i);
        for (var j = 0; j < 2; j++) {
            var childRect_j = GetRectangle("c" + i + j);
            nodes.push(childRect_j);
            for (var k = 0; k < 6; k++) {
                var childRect_k = GetRectangle("c" + i + j + k);
                nodes.push(childRect_k);
                connectors.push(ConnectNodes(childRect_j, childRect_k));
            }
            connectors.push(ConnectNodes(childRect_i, childRect_j));
        }
        connectors.push(ConnectNodes(parentRect, childRect_i));
    }
    return nodes;
}

populateNodes();
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '550px',
    layout: { type: 'SymmetricalLayout', springLength: 80, springFactor: 0.8, maxIteration: 500, margin: { left: 20, top: 20 } },
    nodes: nodes, connectors: connectors,
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Mind Map layout

A mind map is a diagram that displays the nodes as a spider diagram organizes information around a central concept. To create mind map, the type of layout should be set as MindMap.

Tree Orientation in layout

An Orientation of a MindMapTreeLayout is used to arrange the tree layout according to a specific direction. By default, the orientation is set to Horizontal. The following table outlines the various orientation types available:

Orientation Type Description
Horizontal Aligns the tree layout from left to right
Vertical Aligns the tree layout from top to bottom

The following code example illustrates how to create an mindmap layout.

NOTE

If you want to use mind map layout in diagram, you need to inject MindMap in the diagram.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var nodes = [];
var connectors = [];

function ConnectNodes(parentNode, childNode) {
    var connector = {
        id: parentNode.id + childNode.id,
        sourceID: parentNode.id,
        targetID: childNode.id,
        targetDecorator: { shape: 'None' }
    }
    return connector;
}

function GetRectangle(name) {
    var shape = { type: 'Basic', shape: 'Ellipse' };
    var node = { id: name, height: 25, width: 25, borderColor: '#5e5e5e', borderWidth: 1, style: { fill: '#ff6329' }, shape: shape };
    return node;
}

function populateNodes() {
    var parentRect = GetRectangle("p");
    nodes.push(parentRect);
    for (var i = 0; i < 2; i++) {
        var childRect_i = GetRectangle("c" + i);
        nodes.push(childRect_i);
        for (var j = 0; j < 2; j++) {
            var childRect_j = GetRectangle("c" + i + j);
            nodes.push(childRect_j);
            for (var k = 0; k < 6; k++) {
                var childRect_k = GetRectangle("c" + i + j + k);
                nodes.push(childRect_k);
                connectors.push(ConnectNodes(childRect_j, childRect_k));
            }
            connectors.push(ConnectNodes(childRect_i, childRect_j));
        }
        connectors.push(ConnectNodes(parentRect, childRect_i));
    }
    return nodes;
}

populateNodes();
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '550px',
    layout: { type: 'SymmetricalLayout', springLength: 80, springFactor: 0.8, maxIteration: 500, margin: { left: 20, top: 20 } },
    nodes: nodes, connectors: connectors,
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Complex hierarchical tree

Complex hierarchical tree layout is the extended version of the hierarchical tree layout. The child had been two or more parents. To create a complex hierarchical tree, the type of layout should be set as ComplexHierarchicalTree.

Note: If you want to use Complex hierarchical layout in diagram, you need to inject ComplexHierarchicalTree in the diagram.

The following code example illustrates how to create a complex hierarchical tree.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var nodes = [];
var connectors = [];

function ConnectNodes(parentNode, childNode) {
    var connector = {
        id: parentNode.id + childNode.id,
        sourceID: parentNode.id,
        targetID: childNode.id,
        targetDecorator: { shape: 'None' }
    }
    return connector;
}

function GetRectangle(name) {
    var shape = { type: 'Basic', shape: 'Ellipse' };
    var node = { id: name, height: 25, width: 25, borderColor: '#5e5e5e', borderWidth: 1, style: { fill: '#ff6329' }, shape: shape };
    return node;
}

function populateNodes() {
    var parentRect = GetRectangle("p");
    nodes.push(parentRect);
    for (var i = 0; i < 2; i++) {
        var childRect_i = GetRectangle("c" + i);
        nodes.push(childRect_i);
        for (var j = 0; j < 2; j++) {
            var childRect_j = GetRectangle("c" + i + j);
            nodes.push(childRect_j);
            for (var k = 0; k < 6; k++) {
                var childRect_k = GetRectangle("c" + i + j + k);
                nodes.push(childRect_k);
                connectors.push(ConnectNodes(childRect_j, childRect_k));
            }
            connectors.push(ConnectNodes(childRect_i, childRect_j));
        }
        connectors.push(ConnectNodes(parentRect, childRect_i));
    }
    return nodes;
}

populateNodes();
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '550px',
    layout: { type: 'SymmetricalLayout', springLength: 80, springFactor: 0.8, maxIteration: 500, margin: { left: 20, top: 20 } },
    nodes: nodes, connectors: connectors,
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Line Distribution

Line distribution is used to arrange the connectors without overlapping in automatic layout. In some cases, the automatic layout connectors connecting to the nodes will be overlapped with one another. So user can decide whether the segment of each connector from a single parent node should be same point or different point. The connectionPointOrigin property of layout is used to enable or disable the line distribution in layout. By default ConnectionPointOrigin will be SamePoint.

The following code example illustrates how to create a complex hierarchical tree with line distribution.

Note: If you want to use line distribution in diagram layout, you need to inject LineDistribution module in the diagram.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.ComplexHierarchicalTree, ej.diagrams.LineDistribution );
var data = [
        { "Name": "node11" },
        { "Name": "node12", "ReportingPerson": ["node114"] },
        { "Name": "node13", "ReportingPerson": ["node12"] },
        { "Name": "node14", "ReportingPerson": ["node12"] },
        { "Name": "node15", "ReportingPerson": ["node12"] },
        { "Name": "node116", "ReportingPerson": ["node22","node12"] },
        { "Name": "node16", "ReportingPerson": [] },
        { "Name": "node18", "ReportingPerson": [] },
        { "Name": "node21" },
        { "Name": "node22", "ReportingPerson": ["node114"] },
        { "Name": "node23", "ReportingPerson": ["node22"] },
        { "Name": "node24", "ReportingPerson": ["node22"] },
        { "Name": "node25", "ReportingPerson": ["node22"] },
        { "Name": "node26", "ReportingPerson": [] },
        { "Name": "node28", "ReportingPerson": [] },
        { "Name": "node31" },
        { "Name": "node114", "ReportingPerson": ["node11", "node21", "node31"]}
];

var items = new ej.data.DataManager(data, new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '590px',
    //Uses layout to auto-arrange nodes on the diagram page
    layout: {
        //Sets layout type
        type: 'ComplexHierarchicalTree',
        connectionPointOrigin: ej.diagrams.ConnectionPointOrigin.DifferentPoint,
        horizontalSpacing: 40, verticalSpacing: 40, horizontalAlignment: "Left", verticalAlignment: "Top",
        margin: { left: 0, right: 0, top: 0, bottom: 0 },
        orientation: 'TopToBottom'
    },//Configures data source for diagram
    dataSourceSettings: {
        id: 'Name',
        parentId: 'ReportingPerson',
        dataManager: items
    },//Sets the default properties for nodes
    getNodeDefaults: (obj) => {
        obj.width = 40; obj.height = 40;
        obj.shape = { type: 'Basic', shape: 'Rectangle', cornerRadius: 7 };
        obj.style = { fill: '#6BA5D7', strokeColor: 'none', strokeWidth: 2 };
        obj.borderWidth = 1;
        obj.backgroundColor = '#6BA5D7';
        return obj;
    },//Sets the default properties for and connectors
    getConnectorDefaults: (connector, diagram) => {
        connector.type = 'Orthogonal';
        connector.cornerRadius = 7;
        connector.targetDecorator.height = 7;
        connector.targetDecorator.width = 7;
        connector.style = { strokeColor: '#6BA5D7', strokeWidth: 1 };
        connector.targetDecorator.style.fill  =  '#6BA5D7';
        connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
        return connector;
    }
});
diagram.appendTo('#element');
diagram.fitToPage({ mode: 'Width' });
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Linear Arrangement

Linear arrangement is used to linearly arrange the child nodes in layout, which means the parent node is placed in the center corresponding to its children. When line distribution is enabled, linear arrangement is also activated by default. The arrangement property of layout is used to enable or disable the linear arrangement in layout. By default arrangement will be Nonlinear.

Note: If you want to use linear arrangement in diagram layout, you need to inject LineDistribution module in the diagram. Linear arrangement is applicable only for complex hierarchical tree layout.

The following code illustrates how to allow a linear arrangement in diagram layout.

//Initialize diagram
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '590px',
    layout: {
        type: 'ComplexHierarchicalTree',
        //To arrange a child nodes in a linear manner
        arrangement: ChildArrangement.Linear,
        horizontalSpacing: 40, verticalSpacing: 40,
        orientation: 'TopToBottom',
    },
},'#diagram');

Prevent connectors overlay

The below constraints prevents the connector segments overlapping nodes with a complex hierarchical layout.

//Initialize diagram
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '590px',
    layout: {
        //this prevents connector segments overlapping
        enableRouting: true,
    },
},'#diagram');

Customize layout

Orientation, spacings, and position of the layout can be customized with a set of properties.

To explore layout properties, refer to Layout Properties.

Layout bounds

Diagram provides support to align the layout within any custom rectangular area. For more information about bounds, refer to bounds.

Layout alignment

The layout can be aligned anywhere over the layout bounds/viewport using the horizontalAlignment and verticalAlignment properties of the layout.

The following code illustrates how to align the layout at the top-left of the layout bounds.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.ComplexHierarchicalTree, ej.diagrams.LineDistribution );
var data = [
        { "Name": "node11" },
        { "Name": "node12", "ReportingPerson": ["node114"] },
        { "Name": "node13", "ReportingPerson": ["node12"] },
        { "Name": "node14", "ReportingPerson": ["node12"] },
        { "Name": "node15", "ReportingPerson": ["node12"] },
        { "Name": "node116", "ReportingPerson": ["node22","node12"] },
        { "Name": "node16", "ReportingPerson": [] },
        { "Name": "node18", "ReportingPerson": [] },
        { "Name": "node21" },
        { "Name": "node22", "ReportingPerson": ["node114"] },
        { "Name": "node23", "ReportingPerson": ["node22"] },
        { "Name": "node24", "ReportingPerson": ["node22"] },
        { "Name": "node25", "ReportingPerson": ["node22"] },
        { "Name": "node26", "ReportingPerson": [] },
        { "Name": "node28", "ReportingPerson": [] },
        { "Name": "node31" },
        { "Name": "node114", "ReportingPerson": ["node11", "node21", "node31"]}
];

var items = new ej.data.DataManager(data, new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '590px',
    //Uses layout to auto-arrange nodes on the diagram page
    layout: {
        //Sets layout type
        type: 'ComplexHierarchicalTree',
        connectionPointOrigin: ej.diagrams.ConnectionPointOrigin.DifferentPoint,
        horizontalSpacing: 40, verticalSpacing: 40, horizontalAlignment: "Left", verticalAlignment: "Top",
        margin: { left: 0, right: 0, top: 0, bottom: 0 },
        orientation: 'TopToBottom'
    },//Configures data source for diagram
    dataSourceSettings: {
        id: 'Name',
        parentId: 'ReportingPerson',
        dataManager: items
    },//Sets the default properties for nodes
    getNodeDefaults: (obj) => {
        obj.width = 40; obj.height = 40;
        obj.shape = { type: 'Basic', shape: 'Rectangle', cornerRadius: 7 };
        obj.style = { fill: '#6BA5D7', strokeColor: 'none', strokeWidth: 2 };
        obj.borderWidth = 1;
        obj.backgroundColor = '#6BA5D7';
        return obj;
    },//Sets the default properties for and connectors
    getConnectorDefaults: (connector, diagram) => {
        connector.type = 'Orthogonal';
        connector.cornerRadius = 7;
        connector.targetDecorator.height = 7;
        connector.targetDecorator.width = 7;
        connector.style = { strokeColor: '#6BA5D7', strokeWidth: 1 };
        connector.targetDecorator.style.fill  =  '#6BA5D7';
        connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
        return connector;
    }
});
diagram.appendTo('#element');
diagram.fitToPage({ mode: 'Width' });
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Layout spacing

Layout provides support to add space horizontally and vertically between the nodes. The horizontalSpacing and verticalSpacing properties of the layout allows you to set the space between the nodes in horizontally and vertically.

Layout margin

Layout provides support to add some blank space between the layout bounds/viewport and the layout. The margin property of the layout allows you to set the blank space.

The following code illustrates how to set the layout margin.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var data = [
	{Name: "Steve-Ceo"},
	{Name: "Kevin-Manager", ReportingPerson: "Steve-Ceo"},
	{Name: "Peter-Manager", ReportingPerson: "Kevin-Manager"},
	{Name: "John- Manager", ReportingPerson: "Peter-Manager"},
	{Name: "Mary-CSE ", ReportingPerson: "Peter-Manager"},
];

var items = new ej.data.DataManager(data, new ej.data.Query().take(7));

var diagram = new  ej.diagrams.Diagram({
    width: '100%', height: '550px',
    layout: { type: 'HierarchicalTree',bounds:new ej.diagrams.Rect(0,0,500,500),horizontalSpacing:25,verticalSpacing:30,horizontalAlignment:'Left',verticalAlignment:'Top' },
    dataSourceSettings: { id: 'Name', parentId: 'ReportingPerson', dataManager: items },
    getNodeDefaults: (obj) => {
        obj.shape = { type: 'Text', content: (obj.data ).Name };
        obj.style = { fill:'None', strokeColor: 'none',strokeWidth: 2, bold: true, color: 'white'};
        obj.borderColor = 'black';
        obj.width=100;
        obj.height=40;
        obj.backgroundColor = 'darkcyan';
        obj.borderWidth = 1;
        (obj.shape).margin = { left: 25, right: 25, top: 25, bottom: 25 };
        return obj;
    }, getConnectorDefaults: (connector, diagram) => {
        connector.type = 'Orthogonal';
        return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Layout orientation

The layout orientation can used to arrange the layout based on the direction. there are different orientation types that are defined in the following table.

Orientation Description
TopToBottom Aligns the layout from top to bottom. All the roots are placed at top of diagram.
LeftToRight Aligns the layout from left to right. All the roots are placed at left of diagram.
BottomToTop Aligns the layout from bottom to top. All the roots are placed at bottom of the diagram.
RightToLeft Aligns the layout from right to left. All the roots are placed at right of the diagram.

Diagram provides support to customize the orientation of layout. You can set the desired orientation using layout.orientation.

Note: In the diagram the default orientation is TopToBottom.

The following code illustrates how to arrange the nodes in a BottomToTop orientation.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
 var data= [
	{Name: "Steve-Ceo"},
	{Name: "Kevin-Manager", ReportingPerson: "Steve-Ceo"},
	{Name: "Peter-Manager", ReportingPerson: "Steve-Ceo"},
	{Name: "John- Manager", ReportingPerson: "Peter-Manager"},
	{Name: "Mary-CSE ", ReportingPerson: "Peter-Manager"},
	{Name: "Jim-CSE ", ReportingPerson: "Kevin-Manager"},
	{Name: "Martin-CSE", ReportingPerson: "Kevin-Manager"}];

var items = new ej.data.DataManager(data , new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '550px',
     layout: { type: 'HierarchicalTree',bounds:new ej.diagrams.Rect(0,0,500,500),horizontalSpacing:25,verticalSpacing:30,horizontalAlignment:'Left',verticalAlignment:'Top',orientation:'BottomToTop'},
    dataSourceSettings: { id: 'Name', parentId: 'ReportingPerson', dataManager: items },
    getNodeDefaults: (obj) => {
        obj.shape = { type: 'Text', content: (obj.data).Name };
        obj.style = { fill:'None', strokeColor: 'none',strokeWidth: 2, bold: true, color: 'white'};
        obj.borderColor = 'black';
        obj.width=100;
        obj.height=40;
        obj.backgroundColor = 'darkcyan';
        obj.borderWidth = 1;
        (obj.shape ).margin = { left: 25, right: 25, top: 25, bottom: 25 };
        return obj;
    }, getConnectorDefaults: (connector, diagram) => {
        connector.type = 'Orthogonal';
        return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Fixed node

Layout provides support to arrange the nodes with reference to the position of a fixed node and set it to the fixedNode of the layout property. This is helpful when you try to expand/collapse a node. It might be expected that the position of the double-clicked node should not be changed.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
 var data= [
	{Name: "Steve-Ceo"},
	{Name: "Kevin-Manager", ReportingPerson: "Steve-Ceo"},
	{Name: "Peter-Manager", ReportingPerson: "Steve-Ceo"},
	{Name: "John- Manager", ReportingPerson: "Peter-Manager"},
	{Name: "Mary-CSE ", ReportingPerson: "Peter-Manager"},
	{Name: "Jim-CSE ", ReportingPerson: "Kevin-Manager"},
	{Name: "Martin-CSE", ReportingPerson: "Kevin-Manager"}];

var items = new ej.data.DataManager(data , new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '550px',
     layout: { type: 'HierarchicalTree',bounds:new ej.diagrams.Rect(0,0,500,500),horizontalSpacing:25,verticalSpacing:30,horizontalAlignment:'Left',verticalAlignment:'Top',orientation:'BottomToTop'},
    dataSourceSettings: { id: 'Name', parentId: 'ReportingPerson', dataManager: items },
    getNodeDefaults: (obj) => {
        obj.shape = { type: 'Text', content: (obj.data).Name };
        obj.style = { fill:'None', strokeColor: 'none',strokeWidth: 2, bold: true, color: 'white'};
        obj.borderColor = 'black';
        obj.width=100;
        obj.height=40;
        obj.backgroundColor = 'darkcyan';
        obj.borderWidth = 1;
        (obj.shape ).margin = { left: 25, right: 25, top: 25, bottom: 25 };
        return obj;
    }, getConnectorDefaults: (connector, diagram) => {
        connector.type = 'Orthogonal';
        return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Expand and collapse

Diagram allows to expand/collapse the subtrees of a layout. The node’s isExpanded property allows you to expand/collapse its children. The following code example shows how to expand/collapse the children of a node.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var data = [
        {
            'Id': 'parent1', 'Name': 'Maria ', 'Designation': 'Managing Director',
            'ImageUrl': '../content/images/orgchart/Clayton.png', 'IsExpand': 'true', 'RatingColor': '#C34444'
        },
        {
            'Id': 'parent', 'Name': ' sam', 'Designation': 'Managing Director', 'ReportingPerson': 'parent1',
            'ImageUrl': '../content/images/orgchart/Clayton.png', 'IsExpand': 'true', 'RatingColor': '#C34444'
        },
        {
            'Id': 'parent3', 'Name': ' sam geo', 'Designation': 'Managing Director', 'ReportingPerson': 'parent1',
            'ImageUrl': '../content/images/orgchart/Clayton.png', 'IsExpand': 'true', 'RatingColor': '#C34444'
        },
        {
            'Id': '80', 'Name': ' david', 'Designation': 'Managing Director', 'ReportingPerson': 'parent3',
            'ImageUrl': '../content/images/orgchart/Clayton.png', 'IsExpand': 'true', 'RatingColor': '#C34444'
        },
        {
            'Id': '82', 'Name': ' pirlo', 'Designation': 'Managing Director', 'ReportingPerson': 'parent',
            'ImageUrl': '../content/images/orgchart/Clayton.png', 'IsExpand': 'true', 'RatingColor': '#C34444'
        }
];

var items = new ej.data.DataManager(data, new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '590px', selectedItems: { constraints: ~ej.diagrams.SelectorConstraints.ResizeAll },
    snapSettings: { constraints: 0 },
    layout: {
        enableAnimation: true,
        type: 'OrganizationalChart', margin: { top: 20 },
        getLayoutInfo: (node, tree) => {
            if (!tree.hasSubTree) {
                tree.orientation = 'vertical';
                tree.type = 'alternate';
            }
        }
    },
    dataSourceSettings: {
        id: 'Id', parentId: 'ReportingPerson', dataManager: items
    },

    getNodeDefaults: (obj, diagram) => {
        obj.expandIcon = { height: 15, width: 15, shape: "Plus", fill: 'lightgray', offset: { x: .5, y: .85 } }
        obj.collapseIcon.offset = { x: .5, y: .85 }
        obj.collapseIcon.height = 15;
        obj.collapseIcon.width = 15;
        obj.collapseIcon.shape = "Minus";
        obj.collapseIcon.fill = 'lightgray';
        obj.height = 50;
        obj.backgroundColor = 'lightgrey';
        obj.style = { fill: 'transparent', strokeWidth: 2 };
        return obj;
    }, getConnectorDefaults: (connector, diagram) => {
        connector.style = { strokeColor: '#6BA5D7', strokeWidth: 2 };
        connector.targetDecorator.style.fill = '#6BA5D7';
        connector.targetDecorator.style.strokeColor = 'white';
        connector.targetDecorator.shape = 'None';
        connector.type = 'Orthogonal';
        return connector;
    },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

In the previous example, while expanding/collapsing a node, it is set as fixed node in order to prevent it from repositioning.

Refresh layout

Diagram allows to refresh the layout at runtime. To refresh the layout, refer to Refresh layout.

setNodeTemplate

The setNodeTemplate function is provided for the purpose of customizing nodes. It will be called for each node on node initialization. In this function, the node style and its properties can be customized and can bind the custom JSON with node.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
 var data = [
	{Name: "Steve-Ceo"},
	{Name: "Kevin-Manager", ReportingPerson: "Steve-Ceo",color:'darkcyan'},
	{Name: "Peter-Manager", ReportingPerson: "Steve-Ceo",color:'white'},
	{Name: "John- Manager", ReportingPerson: "Peter-Manager",color:'darkcyan'},
	{Name: "Mary-CSE ", ReportingPerson: "Peter-Manager",color:'white'},
	{Name: "Jim-CSE ", ReportingPerson: "Kevin-Manager",color:'darkcyan'},
	{Name: "Martin-CSE", ReportingPerson: "Kevin-Manager",color:'white'}];

var items = new ej.data.DataManager(data, new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: '550px',
     layout: { type: 'HierarchicalTree',bounds:new ej.diagrams.Rect(0,0,500,500),horizontalSpacing:25,verticalSpacing:30,horizontalAlignment:'Left',verticalAlignment:'Top'},
    dataSourceSettings: { id: 'Name', parentId: 'ReportingPerson', dataManager: items },
    getNodeDefaults: (obj) => {
        obj.shape = { type: 'Text', content: (obj.data ).Name };
        obj.style = { fill:'None', strokeColor: 'none',strokeWidth: 2, bold: true, color: 'white'};
        obj.borderColor = 'black';
        obj.width=100;
        obj.height=40;
        obj.backgroundColor = 'darkcyan';
        obj.borderWidth = 1;
        (obj.shape ).margin = { left: 25, right: 25, top: 25, bottom: 25 };
        return obj;
    }, setNodeTemplate: function (obj, diagram) {
        obj.style.color=(obj.data).color;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/23.1.36/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/23.1.36/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Diagram provides support to auto-arrange the nodes in the diagram area that is referred as Layout
. It includes the following layout modes:
The hierarchical tree layout arranges nodes in a tree-like structure, where the nodes in the hierarchical layout may have multiple parents. There is no need to specify the layout root. To arrange the nodes in a hierarchical structure, specify the layout type
as hierarchical tree. The following example shows how to arrange the nodes in a hierarchical structure.
Note: If you want to use hierarchical tree layout in diagram, you need to inject HierarchicalTree in the diagram.
The following example shows how to arrange the nodes in a hierarchical structure.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, HierarchicalTree, DataBinding } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
{
Name: "Jim-CSE ",
ReportingPerson: "Kevin-Manager"
},
{
Name: "Martin-CSE",
ReportingPerson: "Kevin-Manager"
}
];
let items = new DataManager(data, new Query().take(7));
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'550px'}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//Sets layout type
type: 'HierarchicalTree'
}}
//Configures data source for diagram
dataSourceSettings={{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}}
//Sets the default properties for nodes
getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
content: obj.data.Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.borderColor = 'white';
obj.width = 100;
obj.height = 40;
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.shape.margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}}
//Sets the default properties for and connectors
getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
NodeModel,
DiagramConstraints,
HierarchicalTree,
TextModel,
DataBinding
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
{
Name: "Jim-CSE ",
ReportingPerson: "Kevin-Manager"
},
{
Name: "Martin-CSE",
ReportingPerson: "Kevin-Manager"
}
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'550px'
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//Sets layout type
type: 'HierarchicalTree'
}
}
//Configures data source for diagram
dataSourceSettings = {
{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}
}
//Sets the default properties for nodes
getNodeDefaults = {
(obj: NodeModel) => {
obj.shape = {
type: 'Text',
content: (obj.data as {
Name: 'string'
}).Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.borderColor = 'white';
obj.width = 100;
obj.height = 40;
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
(obj.shape as TextModel).margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}
}
//Sets the default properties for and connectors
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
The radial tree layout arranges nodes on a virtual concentric circle around a root node. Sub-trees formed by the branching of child nodes are located radially around the child nodes. This arrangement result in an ever-expanding concentric arrangement with radial proximity to the root node indicating the node level in the hierarchy. The layout root
property can be used to define the root node of the layout. When no root node is set, the algorithm automatically considers one of the diagram nodes as the root node.
To arrange nodes in a radial tree structure, set the type
of the layout as RadialTree
. The following code illustrates how to arrange the nodes in a radial tree structure.
Note: If you want to use radial tree layout in diagram, you need to inject DataBinding and RadialTree in the diagram.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, DataBinding, RadialTree } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
"Id": 1,
"Name": "Ana Trujillo",
"Designation": "Project Manager",
"RatingColor": "#68C2DE"
},
{
"Id": 2,
"Name": "Lino Rodri",
"Designation": "Project Manager",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
},
{
"Id": 3,
"Name": "Philip Cramer",
"Designation": "Project Manager",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
},
{
"Id": 4,
"Name": "Pedro Afonso",
"Designation": "Project Manager",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
},
{
"Id": 5,
"Name": "Anto Moreno",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 6,
"Name": "Elizabeth Roel",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 7,
"Name": "Aria Cruz",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 8,
"Name": "Eduardo Roel",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 9,
"Name": "Howard Snyd",
"Designation": "Project Lead",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
},
{
"Id": 10,
"Name": "Daniel Tonini",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 11,
"Name": "Nardo Batista",
"Designation": "Project Lead",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
}
];
let items = new DataManager(data, new Query().take(5));
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'590px'} snapSettings={{
constraints: 0
}}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//set the type as Radial tree
type: 'RadialTree',
root: 'parent'
}}
//Configures data source for diagram
dataSourceSettings={{
id: 'Id',
parentId: 'ReportingPerson',
dataManager: items
}}
//Sets the default properties for nodes and connectors
getNodeDefaults={(obj, diagram) => {
obj.height = 15;
obj.width = 15;
obj.borderWidth = 1;
obj.style = {
fill: '#6BA5D7',
strokeWidth: 2,
strokeColor: '#6BA5D7'
};
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.targetDecorator.shape = 'None';
connector.type = 'Straight';
return connector;
}}><Inject services={[DataBinding, RadialTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
Node,
NodeModel,
Container,
TextElement,
StackPanel,
ImageElement,
DataBinding,
RadialTree,
TreeInfo,
DiagramTools
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object = [{
"Id": 1,
"Name": "Ana Trujillo",
"Designation": "Project Manager",
"RatingColor": "#68C2DE"
},
{
"Id": 2,
"Name": "Lino Rodri",
"Designation": "Project Manager",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
},
{
"Id": 3,
"Name": "Philip Cramer",
"Designation": "Project Manager",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
},
{
"Id": 4,
"Name": "Pedro Afonso",
"Designation": "Project Manager",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
},
{
"Id": 5,
"Name": "Anto Moreno",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 6,
"Name": "Elizabeth Roel",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 7,
"Name": "Aria Cruz",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 8,
"Name": "Eduardo Roel",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 9,
"Name": "Howard Snyd",
"Designation": "Project Lead",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
},
{
"Id": 10,
"Name": "Daniel Tonini",
"Designation": "Project Lead",
"RatingColor": "#93B85A",
"ReportingPerson": 1
},
{
"Id": 11,
"Name": "Nardo Batista",
"Designation": "Project Lead",
"RatingColor": "#68C2DE",
"ReportingPerson": 1
}
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(5));
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'590px'
}
snapSettings = {
{
constraints: 0
}
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//set the type as Radial tree
type: 'RadialTree',
root: 'parent'
}
}
//Configures data source for diagram
dataSourceSettings = {
{
id: 'Id',
parentId: 'ReportingPerson',
dataManager: items
}
}
//Sets the default properties for nodes and connectors
getNodeDefaults = {
(obj: NodeModel, diagram: Diagram) => {
obj.height = 15;
obj.width = 15;
obj.borderWidth = 1;
obj.style = {
fill: '#6BA5D7',
strokeWidth: 2,
strokeColor: '#6BA5D7'
};
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.targetDecorator.shape = 'None';
connector.type = 'Straight';
return connector;
}
}
><Inject services = {[DataBinding, RadialTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
An organizational chart is a diagram that displays the structure of an organization and relationships. To create an organizational chart, the type
of layout should be set as an OrganizationalChart
.
The following code example illustrates how to create an organizational chart.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, DataBinding, HierarchicalTree } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
Id: "parent",
Role: "Project Management"
},
{
Id: 1,
Role: "R&D Team",
Team: "parent"
},
{
Id: 3,
Role: "Philosophy",
Team: "1"
},
{
Id: 4,
Role: "Organization",
Team: "1"
},
{
Id: 5,
Role: "Technology",
Team: "1"
},
{
Id: 7,
Role: "Funding",
Team: "1"
},
{
Id: 8,
Role: "Resource Allocation",
Team: "1"
},
{
Id: 9,
Role: "Targeting",
Team: "1"
},
{
Id: 11,
Role: "Evaluation",
Team: "1"
},
{
Id: 156,
Role: "HR Team",
Team: "parent"
},
{
Id: 13,
Role: "Recruitment",
Team: "156"
},
{
Id: 113,
Role: "Training",
Team: "12"
},
{
Id: 112,
Role: "Employee Relation",
Team: "156"
},
{
Id: 14,
Role: "Record Keeping",
Team: "12"
},
{
Id: 15,
Role: "Compensations & Benefits",
Team: "12"
},
{
Id: 16,
Role: "Compliances",
Team: "12"
},
{
Id: 17,
Role: "Production & Sales Team",
Team: "parent"
},
{
Id: 119,
Role: "Design",
Team: "17"
},
{
Id: 19,
Role: "Operation",
Team: "17"
},
{
Id: 20,
Role: "Support",
Team: "17"
},
{
Id: 21,
Role: "Quality Assurance",
Team: "17"
},
{
Id: 23,
Role: "Customer Interaction",
Team: "17"
},
{
Id: 24,
Role: "Support and Maintenance",
Team: "17"
},
{
Id: 25,
Role: "Task Coordination",
Team: "17"
}
];
let items = new DataManager(data, new Query().take(5));
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'550px'}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//set the type as Organizational Chart
type: 'OrganizationalChart',
enableAnimation: true,
margin: { top: 20 },
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}}
//Configures data source for diagram
dataSourceSettings={{
id: 'Id',
parentId: 'Team',
dataManager: items
}}
//Sets the default properties for nodes and connectors
getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
content: obj.data.Role
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.width = 75;
obj.height = 40;
obj.shape.margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
Node,
NodeModel,
Container,
TextElement,
StackPanel,
ImageElement,
DataBinding,
TextModel,
HierarchicalTree,
TreeInfo,
DiagramTools
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
Id: "parent",
Role: "Project Management"
},
{
Id: 1,
Role: "R&D Team",
Team: "parent"
},
{
Id: 3,
Role: "Philosophy",
Team: "1"
},
{
Id: 4,
Role: "Organization",
Team: "1"
},
{
Id: 5,
Role: "Technology",
Team: "1"
},
{
Id: 7,
Role: "Funding",
Team: "1"
},
{
Id: 8,
Role: "Resource Allocation",
Team: "1"
},
{
Id: 9,
Role: "Targeting",
Team: "1"
},
{
Id: 11,
Role: "Evaluation",
Team: "1"
},
{
Id: 156,
Role: "HR Team",
Team: "parent"
},
{
Id: 13,
Role: "Recruitment",
Team: "156"
},
{
Id: 113,
Role: "Training",
Team: "12"
},
{
Id: 112,
Role: "Employee Relation",
Team: "156"
},
{
Id: 14,
Role: "Record Keeping",
Team: "12"
},
{
Id: 15,
Role: "Compensations & Benefits",
Team: "12"
},
{
Id: 16,
Role: "Compliances",
Team: "12"
},
{
Id: 17,
Role: "Production & Sales Team",
Team: "parent"
},
{
Id: 119,
Role: "Design",
Team: "17"
},
{
Id: 19,
Role: "Operation",
Team: "17"
},
{
Id: 20,
Role: "Support",
Team: "17"
},
{
Id: 21,
Role: "Quality Assurance",
Team: "17"
},
{
Id: 23,
Role: "Customer Interaction",
Team: "17"
},
{
Id: 24,
Role: "Support and Maintenance",
Team: "17"
},
{
Id: 25,
Role: "Task Coordination",
Team: "17"
}
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(5));
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'550px'
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//set the type as Organizational Chart
type: 'OrganizationalChart',
enableAnimation: true,
margin: { top: 20 },
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}
}
//Configures data source for diagram
dataSourceSettings = {
{
id: 'Id',
parentId: 'Team',
dataManager: items
}
}
//Sets the default properties for nodes and connectors
getNodeDefaults = {
(obj: NodeModel) => {
obj.shape = {
type: 'Text',
content: (obj.data as {
Role: 'string'
}).Role
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.width = 75;
obj.height = 40;
(obj.shape as TextModel).margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
Organizational chart layout starts parsing from root and iterate through all its child elements. The getLayoutInfo
method provides necessary information of a node’s children and the way to arrange (direction, orientation, offsets, etc.) them. The arrangements can be customized by overriding this function as explained.
GetLayoutInfo
Set chart orientations, chart types, and offset to be left between parent and child nodes by overriding the method, diagram.layout.getLayoutInfo
. The getLayoutInfo
method is called to configure every subtree of the organizational chart. It takes the following arguments.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, DataBinding, HierarchicalTree, SnapConstraints } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
Id: 1,
Role: "General Manager"
},
{
Id: 2,
Role: "Assistant Manager",
Team: 1
},
{
Id: 3,
Role: "Human Resource Manager",
Team: 1
},
{
Id: 4,
Role: "Design Manager",
Team: 1
},
{
Id: 5,
Role: "Operation Manager",
Team: 1
},
{
Id: 6,
Role: "Marketing Manager",
Team: 1
}
];
let items = new DataManager(data, new Query().take(7));
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'530px'} snapSettings={{
constraints: SnapConstraints.None
}}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//Sets layout type
type: 'OrganizationalChart',
getLayoutInfo: (node, options) => {
if (!options.hasSubTree) {
options.type = 'Center';
options.orientation = 'Horizontal';
}
}
}}
//Configures data source for diagram
dataSourceSettings={{
id: 'Id',
parentId: 'Team',
dataManager: items
}}
//Sets the default properties for nodes and connectors
getNodeDefaults={(obj, diagram) => {
obj.width = 150;
obj.height = 50;
obj.style.fill = '#6BA5D7';
obj.annotations = [{
content: obj.data['Role'],
style: {
color: 'white'
}
}];
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.targetDecorator.shape = 'None';
connector.targetDecorator.shape = 'None';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
Node,
NodeModel,
DataBinding,
HierarchicalTree,
SnapConstraints,
TreeInfo
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
Id: 1,
Role: "General Manager"
},
{
Id: 2,
Role: "Assistant Manager",
Team: 1
},
{
Id: 3,
Role: "Human Resource Manager",
Team: 1
},
{
Id: 4,
Role: "Design Manager",
Team: 1
},
{
Id: 5,
Role: "Operation Manager",
Team: 1
},
{
Id: 6,
Role: "Marketing Manager",
Team: 1
}
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'530px'
}
snapSettings = {
{
constraints: SnapConstraints.None
}
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//Sets layout type
type: 'OrganizationalChart',
getLayoutInfo: (node: Node, options: TreeInfo) => {
if (!options.hasSubTree) {
options.type = 'Center';
options.orientation = 'Horizontal';
}
}
}
}
//Configures data source for diagram
dataSourceSettings = {
{
id: 'Id',
parentId: 'Team',
dataManager: items
}
}
//Sets the default properties for nodes and connectors
getNodeDefaults = {
(obj: NodeModel, diagram: Diagram) => {
obj.width = 150;
obj.height = 50;
obj.style.fill = '#6BA5D7';
obj.annotations = [{
content: obj.data['Role'],
style: {
color: 'white'
}
}];
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.targetDecorator.shape = 'None';
connector.targetDecorator.shape = 'None';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
The following table illustrates the properties that “options” argument takes.
Property | Description | Default Value |
---|---|---|
options.assistants | By default, the collection is empty. When any of the child nodes have to be set as Assistant, you can remove from children collection and have to insert into assistants collection. | Empty array |
options.orientation | Gets or sets the organizational chart orientation. | SubTreeOrientation.Vertical |
options.type | Gets or sets the chart organizational chart type. | For horizontal chart orientation:SubTreeAlignments.Center and for vertical chart orientation:SubTreeAlignments.Alternate |
options.offset | Offset is the horizontal space to be left between parent and child nodes. | 20 pixels applicable only for vertical chart orientations. |
options.hasSubTree | Gets whether the node contains subtrees. | Boolean |
options.level | Gets the depth of the node from layout root. | Number |
options.enableRouting | By default, connections are routed based on the chart type and orientations. This property gets or sets whether default routing is to be enabled or disabled. | true |
options.rows | Sets the number of rows on which the child nodes will be arranged. Applicable only for balanced type horizontal tree. | Number |
The following table illustrates the different chart orientations and chart types.
Orientation | Type | Description | Example |
---|---|---|---|
Horizontal | Left | Arranges the child nodes horizontally at the left side of the parent. |
![]() |
Right | Arranges the child nodes horizontally at the right side of the parent. |
![]() |
|
Center | Arranges the children like standard tree layout orientation. |
![]() |
|
Balanced | Arranges the leaf level child nodes in multiple rows. |
![]() |
|
Vertical | Left | Arranges the children vertically at the left side of the parent. |
![]() |
Right | Arranges the children vertically at the right side of the parent. |
![]() |
|
Alternate | Arranges the children vertically at both left and right sides of the parent. |
![]() |
The following code example illustrates how to set the vertical right arrangement to the leaf level trees.
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
Node,
NodeModel,
DataBinding,
HierarchicalTree,
TreeInfo
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
Id: "parent",
Role: "Board"
},
{
Id: "1",
Role: "General Manager",
Manager: "parent"
},
{
Id: "2",
Role: "Human Resource Manager",
Manager: "1"
},
{
Id: "3",
Role: "Trainers",
Manager: "2"
},
{
Id: "4",
Role: "Recruiting Team",
Manager: "2"
},
{
Id: "6",
Role: "Design Manager",
Manager: "1"
},
{
Id: "7",
Role: "Design Supervisor",
Manager: "6"
},
{
Id: "8",
Role: "Development Supervisor",
Manager: "6"
},
{
Id: "9",
Role: "Drafting Supervisor",
Manager: "6"
},
{
Id: "10",
Role: "Marketing Manager",
Manager: "1"
},
{
Id: "11",
Role: "Oversea sales Manager",
Manager: "10"
},
{
Id: "12",
Role: "Petroleum Manager",
Manager: "10"
},
{
Id: "13",
Role: "Service Dept. Manager",
Manager: "10"
},
];
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
heigh = {
'530px'
}
snapSettings = {
{
constraints: 0
}
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//Sets layout type
type: 'OrganizationalChart',
getLayoutInfo: (node: Node, options: TreeInfo) => {
if (node.data['Role'] === 'General Manager') {
options.assistants.push(options.children[0]);
options.children.splice(0, 1);
}
if (!options.hasSubTree) {
options.type = 'Right';
options.orientation = 'Vertical';
}
}
}
}
//Configures data source for diagram
dataSourceSettings = {
{
id: 'Id',
parentId: 'Manager',
dataManager: new DataManager(data as JSON[]),
}
}
//Sets the default properties for nodes and connectors
getNodeDefaults = {
(obj: NodeModel, diagram: Diagram) => {
obj.width = 150;
obj.height = 50;
obj.borderColor = 'white';
obj.style.fill = '#6BA5D7';
obj.borderWidth = 1;
obj.annotations = [{
content: obj.data['Role'],
style: {
color: 'white'
}
}];
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.targetDecorator.shape = 'None';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
Assistants are child item that have a different relationship with the parent node. They are laid out in a dedicated part of the tree. A node can be specified as an assistant of its parent by adding it to the assistants
property of the argument “options”.
The following code example illustrates how to add assistants to layout.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, DataBinding, HierarchicalTree, } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data
let data = [{
Id: 1,
Role: "General Manager"
},
{
Id: 2,
Role: "Assistant Manager",
Team: 1
},
{
Id: 3,
Role: "Human Resource Manager",
Team: 1
},
{
Id: 4,
Role: "Design Manager",
Team: 1
},
{
Id: 5,
Role: "Operation Manager",
Team: 1
},
{
Id: 6,
Role: "Marketing Manager",
Team: 1
}
];
let items = new DataManager(data, new Query().take(7));
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'530px'} snapSettings={{
constraints: 0
}}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//Sets layout type
type: 'OrganizationalChart',
// define the getLayoutInfo
getLayoutInfo: (node, options) => {
if (node.data['Role'] === 'General Manager') {
options.assistants.push(options.children[0]);
options.children.splice(0, 1);
}
if (!options.hasSubTree) {
options.type = 'Center';
options.orientation = 'Horizontal';
}
}
}}
//Initializes the node template.
dataSourceSettings={{
id: 'Id',
parentId: 'Team',
dataManager: items
}}
//Sets the default properties for nodes and connectors
getNodeDefaults={(obj, diagram) => {
obj.width = 150;
obj.height = 50;
obj.borderColor = 'white';
obj.style.fill = '#6BA5D7';
obj.borderWidth = 1;
obj.annotations = [{
content: obj.data['Role'],
style: {
color: 'white'
}
}];
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.targetDecorator.shape = 'None';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
Node,
NodeModel,
DataBinding,
HierarchicalTree,
TreeInfo,
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data
let data: object[] = [{
Id: 1,
Role: "General Manager"
},
{
Id: 2,
Role: "Assistant Manager",
Team: 1
},
{
Id: 3,
Role: "Human Resource Manager",
Team: 1
},
{
Id: 4,
Role: "Design Manager",
Team: 1
},
{
Id: 5,
Role: "Operation Manager",
Team: 1
},
{
Id: 6,
Role: "Marketing Manager",
Team: 1
}
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'530px'
}
snapSettings = {
{
constraints: 0
}
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//Sets layout type
type: 'OrganizationalChart',
// define the getLayoutInfo
getLayoutInfo: (node: Node, options: TreeInfo) => {
if (node.data['Role'] === 'General Manager') {
options.assistants.push(options.children[0]);
options.children.splice(0, 1);
}
if (!options.hasSubTree) {
options.type = 'Center';
options.orientation = 'Horizontal';
}
}
}
}
//Initializes the node template.
dataSourceSettings = {
{
id: 'Id',
parentId: 'Team',
dataManager: items
}
}
//Sets the default properties for nodes and connectors
getNodeDefaults = {
(obj: NodeModel, diagram: Diagram) => {
obj.width = 150;
obj.height = 50;
obj.borderColor = 'white';
obj.style.fill = '#6BA5D7';
obj.borderWidth = 1;
obj.annotations = [{
content: obj.data['Role'],
style: {
color: 'white'
}
}];
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.targetDecorator.shape = 'None';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
The symmetric layout has been formed using nodes position by closer together or pushing them further apart. This is repeated iteratively until the system comes to an equilibrium state.
The layout’s springLength
defined as how long edges should be, ideally. This will be the resting length for the springs. Edge attraction and vertex repulsion forces to be defined by using layout’s springFactor
, the more sibling nodes repel each other. The relative positions do not change any more from one iteration to the next. The number of iterations can be specified by using layout’s maxIteration
.
Note: If you want to use symmetric layout in diagram, you need to inject SymmetricLayout in the diagram.
The following code illustrates how to arrange the nodes in a radial tree structure.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, SymmetricLayout } from "@syncfusion/ej2-react-diagrams";
let nodes = [];
let connectors = [];
// creating the connection between the layout nodes and connectors.
export function ConnectNodes(parentNode, childNode) {
let connector = {
id: parentNode.id + childNode.id,
sourceID: parentNode.id,
targetID: childNode.id,
targetDecorator: {
shape: 'None'
}
};
return connector;
}
// creating the layout nodes as rectangle in shape.
export function GetRectangle(name) {
let shape = {
type: 'Basic',
shape: 'Ellipse'
};
let node = {
id: name,
height: 25,
width: 25,
borderColor: 'white',
borderWidth: 1,
style: {
fill: '#6BA5D7'
},
shape: shape
};
return node;
}
// creating the symmetrical layout child elements hierarchy.
export function populateNodes() {
let parentRect = GetRectangle("p");
nodes.push(parentRect);
for (let i = 0; i < 2; i++) {
let childRect_i = GetRectangle("c" + i);
nodes.push(childRect_i);
for (let j = 0; j < 2; j++) {
let childRect_j = GetRectangle("c" + i + j);
nodes.push(childRect_j);
for (let k = 0; k < 6; k++) {
let childRect_k = GetRectangle("c" + i + j + k);
nodes.push(childRect_k);
connectors.push(ConnectNodes(childRect_j, childRect_k));
}
connectors.push(ConnectNodes(childRect_i, childRect_j));
}
connectors.push(ConnectNodes(parentRect, childRect_i));
}
return nodes;
}
//sets the layout child elements
populateNodes();
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'550px'} layout={{
//sets the layout as symmetric layout
type: 'SymmetricalLayout',
springLength: 80,
springFactor: 0.8,
maxIteration: 500,
margin: {
left: 20,
top: 20
}
}} nodes={nodes} connectors={connectors} getNodeDefaults={(obj, diagram) => {
obj.borderColor = 'white';
obj.borderWidth = 1;
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
return connector;
}}><Inject services={[SymmetricLayout]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
IConnector,
DataBinding,
HierarchicalTree,
LayoutOrientation,
LayoutType,
Rect,
HorizontalAlignment,
VerticalAlignment,
NodeModel,
BasicShapeModel,
SymmetricLayout
} from "@syncfusion/ej2-react-diagrams";
let nodes: NodeModel[] = [];
let connectors: ConnectorModel[] = [];
// creating the connection between the layout nodes and connectors.
export function ConnectNodes(parentNode: NodeModel, childNode: NodeModel): ConnectorModel {
let connector: ConnectorModel = {
id: parentNode.id + childNode.id,
sourceID: parentNode.id,
targetID: childNode.id,
targetDecorator: {
shape: 'None'
}
}
return connector;
}
// creating the layout nodes as rectangle in shape.
export function GetRectangle(name: string): NodeModel {
let shape: BasicShapeModel = {
type: 'Basic',
shape: 'Ellipse'
};
let node: NodeModel = {
id: name,
height: 25,
width: 25,
borderColor: 'white',
borderWidth: 1,
style: {
fill: '#6BA5D7'
},
shape: shape
};
return node;
}
// creating the symmetrical layout child elements hierarchy.
export function populateNodes() {
let parentRect: NodeModel = GetRectangle("p");
nodes.push(parentRect);
for (let i: number = 0; i < 2; i++) {
let childRect_i: NodeModel = GetRectangle("c" + i);
nodes.push(childRect_i);
for (let j: number = 0; j < 2; j++) {
let childRect_j: NodeModel = GetRectangle("c" + i + j);
nodes.push(childRect_j);
for (let k: number = 0; k < 6; k++) {
let childRect_k: NodeModel = GetRectangle("c" + i + j + k);
nodes.push(childRect_k);
connectors.push(ConnectNodes(childRect_j, childRect_k));
}
connectors.push(ConnectNodes(childRect_i, childRect_j));
}
connectors.push(ConnectNodes(parentRect, childRect_i));
}
return nodes;
}
//sets the layout child elements
populateNodes();
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'550px'
}
layout = {
{
//sets the layout as symmetric layout
type: 'SymmetricalLayout',
springLength: 80,
springFactor: 0.8,
maxIteration: 500,
margin: {
left: 20,
top: 20
}
}
}
nodes = {
nodes
}
connectors = {
connectors
}
getNodeDefaults = {
(obj: NodeModel, diagram: Diagram) => {
obj.borderColor = 'white';
obj.borderWidth = 1;
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
return connector;
}
}
><Inject services = {[SymmetricLayout]}/>
</DiagramComponent>, document.getElementById("diagram") );
A mind map is a diagram that displays the nodes as a spider diagram organizes information around a central concept. To create mind map, the type
of layout should be set as MindMap
.
The following code example illustrates how to create an organizational chart.
Note: If you want to use mind map layout in diagram, you need to inject MindMap in the diagram.
The following code example illustrates how to create an organizational chart.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, DataBinding, MindMap } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
id: 1,
Label: 'StackPanel'
},
{
id: 2,
Label: 'Label',
parentId: 1
},
{
id: 3,
Label: 'ListBox',
parentId: 1
},
{
id: 4,
Label: 'StackPanel',
parentId: 2
},
{
id: 5,
Label: 'Border',
parentId: 2
},
{
id: 6,
Label: 'Border',
parentId: 4
},
{
id: 7,
Label: 'Button',
parentId: 4
},
{
id: 8,
Label: 'ContentPresenter',
parentId: 5
},
{
id: 9,
Label: 'Text Block',
parentId: 5
},
];
let items = new DataManager(data, new Query().take(7));
// Initializes Diagram
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'550px'}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//Sets layout type
type: 'MindMap'
}}
//Configures data source for diagram
dataSourceSettings={{
id: 'id',
parentId: 'parentId',
dataManager: items,
root: String(1)
}}
//Sets the default properties for nodes and connectors
getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
content: obj.data.Label,
};
obj.style = {
fill: '#6BA5D7',
strokeColor: 'none',
strokeWidth: 2
};
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.shape.margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[DataBinding, MindMap]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
Node,
DataBinding,
LayoutType,
Rect,
HorizontalAlignment,
VerticalAlignment,
NodeModel,
TextModel,
MindMap
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
id: 1,
Label: 'StackPanel'
},
{
id: 2,
Label: 'Label',
parentId: 1
},
{
id: 3,
Label: 'ListBox',
parentId: 1
},
{
id: 4,
Label: 'StackPanel',
parentId: 2
},
{
id: 5,
Label: 'Border',
parentId: 2
},
{
id: 6,
Label: 'Border',
parentId: 4
},
{
id: 7,
Label: 'Button',
parentId: 4
},
{
id: 8,
Label: 'ContentPresenter',
parentId: 5
},
{
id: 9,
Label: 'Text Block',
parentId: 5
},
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
// Initializes Diagram
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'550px'
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//Sets layout type
type: 'MindMap'
}
}
//Configures data source for diagram
dataSourceSettings = {
{
id: 'id',
parentId: 'parentId',
dataManager: items,
root: String(1)
}
}
//Sets the default properties for nodes and connectors
getNodeDefaults = {
(obj: NodeModel) => {
obj.shape = {
type: 'Text',
content: (obj.data as {
Label: 'string'
}).Label,
};
obj.style = {
fill: '#6BA5D7',
strokeColor: 'none',
strokeWidth: 2
};
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
(obj.shape as TextModel).margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, MindMap]}/>
</DiagramComponent>, document.getElementById("diagram") );
Complex hierarchical tree layout is the extended version of the hierarchical tree layout. The child had been two or more parents. To create a complex hierarchical tree, the type
of layout should be set as ComplexHierarchicalTree
.
Note: If you want to use Complex hierarchical layout in diagram, you need to inject ComplexHierarchicalTree in the diagram.
The following code example illustrates how to create a complex hierarchical tree.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, DataBinding, ComplexHierarchicalTree } from "@syncfusion/ej2-react-diagrams";
//Initializes nodes
let node = [{
id: 'node1',
width: 70,
height: 70,
annotations: [{
content: 'node1'
}]
}, {
id: 'node2',
width: 70,
height: 70,
annotations: [{
content: 'node2'
}]
}, {
id: 'node3',
width: 70,
height: 70,
annotations: [{
content: 'node3'
}]
}, {
id: 'node4',
width: 70,
height: 70,
annotations: [{
content: 'node4'
}]
}, {
id: 'node5',
width: 70,
height: 70,
annotations: [{
content: 'node5'
}]
}, {
id: 'node8',
width: 70,
height: 70,
annotations: [{
content: 'node8'
}]
}, {
id: 'node9',
width: 70,
height: 70,
annotations: [{
content: 'node9'
}]
}];
let connector = [{
id: 'connectr',
sourceID: 'node1',
targetID: 'node4'
}, {
id: 'connectr1',
sourceID: 'node2',
targetID: 'node4'
}, {
id: 'connectr3',
sourceID: 'node3',
targetID: 'node4'
}, {
id: 'connectr4',
sourceID: 'node4',
targetID: 'node5'
}];
ReactDOM.render(<DiagramComponent id="diagram" width={1000} height={1000} nodes={node} connectors={connector}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//Sets layout type
type: 'ComplexHierarchicalTree',
orientation: 'TopToBottom'
}}
//Sets the default properties for nodes and connectors
getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
};
obj.style = {
fill: '#6BA5D7',
strokeColor: 'none',
strokeWidth: 2
};
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.shape.margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[ComplexHierarchicalTree, DataBinding]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
NodeModel,
TextModel,
DataBinding,
DiagramConstraints,
ComplexHierarchicalTree
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes nodes
let node: NodeModel[] = [{
id: 'node1',
width: 70,
height: 70,
annotations: [{
content: 'node1'
}]
}, {
id: 'node2',
width: 70,
height: 70,
annotations: [{
content: 'node2'
}]
}, {
id: 'node3',
width: 70,
height: 70,
annotations: [{
content: 'node3'
}]
}, {
id: 'node4',
width: 70,
height: 70,
annotations: [{
content: 'node4'
}]
}, {
id: 'node5',
width: 70,
height: 70,
annotations: [{
content: 'node5'
}]
}, {
id: 'node8',
width: 70,
height: 70,
annotations: [{
content: 'node8'
}]
}, {
id: 'node9',
width: 70,
height: 70,
annotations: [{
content: 'node9'
}]
}];
let connector: ConnectorModel[] = [{
id: 'connectr',
sourceID: 'node1',
targetID: 'node4'
}, {
id: 'connectr1',
sourceID: 'node2',
targetID: 'node4'
}, {
id: 'connectr3',
sourceID: 'node3',
targetID: 'node4'
}, {
id: 'connectr4',
sourceID: 'node4',
targetID: 'node5'
}];
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
1000
}
height = {
1000
}
nodes = {
node
}
connectors = {
connector
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//Sets layout type
type: 'ComplexHierarchicalTree',
orientation: 'TopToBottom'
}
}
//Sets the default properties for nodes and connectors
getNodeDefaults = {
(obj: NodeModel) => {
obj.shape = {
type: 'Text',
};
obj.style = {
fill: '#6BA5D7',
strokeColor: 'none',
strokeWidth: 2
};
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
(obj.shape as TextModel).margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[ComplexHierarchicalTree, DataBinding]}/>
</DiagramComponent>, document.getElementById("diagram") );
Line distribution is used to arrange the connectors without overlapping in automatic layout. In some cases, the automatic layout connectors connecting to the nodes will be overlapped with one another. So user can decide whether the segment of each connector from a single parent node should be same point or different point. The connectionPointOrigin
property of layout is used to enable or disable the line distribution in layout. By default ConnectionPointOrigin will be SamePoint
.
The following code example illustrates how to create a complex hierarchical tree with line distribution.
Note: If you want to use line distribution in diagram layout, you need to inject LineDistribution module in the diagram.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, ComplexHierarchicalTree, ConnectionPointOrigin, LineDistribution, DataBinding } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
let diagramInstance;
//Initializes data source
let data = [
{ "Name": "node11" },
{ "Name": "node12", "ReportingPerson": ["node114"] },
{ "Name": "node13", "ReportingPerson": ["node12"] },
{ "Name": "node14", "ReportingPerson": ["node12"] },
{ "Name": "node15", "ReportingPerson": ["node12"] },
{ "Name": "node116", "ReportingPerson": ["node22", "node12"] },
{ "Name": "node16", "ReportingPerson": [] },
{ "Name": "node18", "ReportingPerson": [] },
{ "Name": "node21" },
{ "Name": "node22", "ReportingPerson": ["node114"] },
{ "Name": "node23", "ReportingPerson": ["node22"] },
{ "Name": "node24", "ReportingPerson": ["node22"] },
{ "Name": "node25", "ReportingPerson": ["node22"] },
{ "Name": "node26", "ReportingPerson": [] },
{ "Name": "node28", "ReportingPerson": [] },
{ "Name": "node31" },
{ "Name": "node114", "ReportingPerson": ["node11", "node21", "node31"] }
];
let items = new DataManager(data, new Query().take(7));
// Initializes the diagram
ReactDOM.render(<DiagramComponent id="diagram" ref={diagram => (diagramInstance = diagram)} width={'100%'} height={'590px'} snapSettings={{
constraints: 0
}} created={(args) => {
diagramInstance.fitToPage({ mode: 'Width' });
}} layout={{
type: 'ComplexHierarchicalTree',
connectionPointOrigin: ConnectionPointOrigin.DifferentPoint,
horizontalSpacing: 40, verticalSpacing: 40, horizontalAlignment: "Left", verticalAlignment: "Top",
margin: { left: 0, right: 0, top: 0, bottom: 0 },
orientation: 'TopToBottom'
}} dataSourceSettings={{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}} getNodeDefaults={(obj) => {
obj.width = 40;
obj.height = 40;
obj.shape = { type: 'Basic', shape: 'Rectangle' };
obj.style = { fill: '#6BA5D7', strokeColor: 'none', strokeWidth: 2 };
obj.borderWidth = 1;
obj.backgroundColor = '#6BA5D7';
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.type = 'Orthogonal';
connector.cornerRadius = 7;
connector.targetDecorator.height = 7;
connector.targetDecorator.width = 7;
connector.style = { strokeColor: '#6BA5D7', strokeWidth: 1 };
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
return connector;
}}><Inject services={[DataBinding, ComplexHierarchicalTree, LineDistribution]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
NodeModel,
DiagramConstraints,
ComplexHierarchicalTree,
ConnectionPointOrigin,
LineDistribution,
DataBinding,
Rect
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
let diagramInstance:Diagram
//Initializes data source
let data: object[] = [
{ "Name": "node11" },
{ "Name": "node12", "ReportingPerson": ["node114"] },
{ "Name": "node13", "ReportingPerson": ["node12"] },
{ "Name": "node14", "ReportingPerson": ["node12"] },
{ "Name": "node15", "ReportingPerson": ["node12"] },
{ "Name": "node116", "ReportingPerson": ["node22","node12"] },
{ "Name": "node16", "ReportingPerson": [] },
{ "Name": "node18", "ReportingPerson": [] },
{ "Name": "node21" },
{ "Name": "node22", "ReportingPerson": ["node114"] },
{ "Name": "node23", "ReportingPerson": ["node22"] },
{ "Name": "node24", "ReportingPerson": ["node22"] },
{ "Name": "node25", "ReportingPerson": ["node22"] },
{ "Name": "node26", "ReportingPerson": [] },
{ "Name": "node28", "ReportingPerson": [] },
{ "Name": "node31" },
{ "Name": "node114", "ReportingPerson": ["node11", "node21", "node31"]}
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
// Initializes the diagram
ReactDOM.render( <DiagramComponent id = "diagram" ref={diagram => (diagramInstance = diagram)}
width = {
'100%'
}
height = {
'590px'
}
snapSettings = {
{
constraints: 0
}
}
created={(args) => {
diagramInstance.fitToPage({ mode: 'Width' });
}}
layout = {
{
type: 'ComplexHierarchicalTree',
connectionPointOrigin: ConnectionPointOrigin.DifferentPoint,
horizontalSpacing: 40, verticalSpacing: 40, horizontalAlignment: "Left", verticalAlignment: "Top",
margin: { left: 0, right: 0, top: 0, bottom: 0 },
orientation: 'TopToBottom'
}
}
dataSourceSettings = {
{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}
}
getNodeDefaults = {
(obj: Node) => {
obj.width = 40; obj.height = 40;
obj.shape = { type: 'Basic', shape: 'Rectangle' };
obj.style = { fill: '#6BA5D7', strokeColor: 'none', strokeWidth: 2 };
obj.borderWidth = 1;
obj.backgroundColor = '#6BA5D7';
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.type = 'Orthogonal';
connector.cornerRadius = 7;
connector.targetDecorator.height = 7;
connector.targetDecorator.width = 7;
connector.style = { strokeColor: '#6BA5D7', strokeWidth: 1 };
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
return connector;
}
}
><Inject services = {[DataBinding, ComplexHierarchicalTree, LineDistribution]}/>
</DiagramComponent>, document.getElementById("diagram") );
Linear arrangement is used to linearly arrange the child nodes in layout, which means the parent node is placed in the center corresponding to its children. When line distribution is enabled, linear arrangement is also activated by default. The arrangement
property of layout is used to enable or disable the linear arrangement in layout. By default childArrangement will be Nonlinear
.
Note: If you want to use linear arrangement in diagram layout, you need to inject LineDistribution module in the diagram. Linear arrangement is applicable only for complex hierarchical tree layout.
ReactDOM.render( < DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'590px'
}
layout = {
{
type: 'ComplexHierarchicalTree',
//To arrange a child nodes in a linear manner
arrangement: ChildArrangement.Linear,
horizontalSpacing: 40, verticalSpacing: 40,
orientation: 'TopToBottom',
}
}
><Inject services = {[DataBinding, ComplexHierarchicalTree, LineDistribution]}/>
</DiagramComponent>, document.getElementById("diagram") );
The below constraints prevents the connector segments overlapping nodes with a complex hierarchical layout.
ReactDOM.render( < DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'590px'
}
layout = {
{
//this prevents connector segments overlapping
enableRouting: true,
}
}
><Inject services = {[DataBinding, ComplexHierarchicalTree, LineDistribution]}/>
</DiagramComponent>, document.getElementById("diagram") );
Orientation, spacings, and position of the layout can be customized with a set of properties.
To explore layout properties, refer to Layout Properties
.
Diagram provides support to align the layout within any custom rectangular area. For more information about bounds, refer to bounds
.
The layout can be aligned anywhere over the layout bounds/viewport using the horizontalAlignment
and verticalAlignment
properties of the layout.
The following code illustrates how to align the layout at the top-left of the layout bounds.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, HierarchicalTree, DataBinding, Rect } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Kevin-Manager"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
];
let items = new DataManager(data, new Query().take(7));
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'550px'}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//Sets layout type
type: 'HierarchicalTree',
//set layout alignment
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}} dataSourceSettings={{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}} getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
content: obj.data.Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 100;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
NodeModel,
DiagramConstraints,
HierarchicalTree,
TextModel,
DataBinding,
Rect
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Kevin-Manager"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'550px'
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//Sets layout type
type: 'HierarchicalTree',
//set layout alignment
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}
}
dataSourceSettings = {
{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}
}
getNodeDefaults = {
(obj: NodeModel) => {
obj.shape = {
type: 'Text',
content: (obj.data as {
Name: 'string'
}).Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 100;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
Layout provides support to add space horizontally and vertically between the nodes. The horizontalSpacing
and verticalSpacing
properties of the layout allows you to set the space between the nodes in horizontally and vertically.
Layout provides support to add some blank space between the layout bounds/viewport and the layout. The margin
property of the layout allows you to set the blank space.
The following code illustrates how to set the layout margin.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, HierarchicalTree, DataBinding, Rect } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Kevin-Manager"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
];
let items = new DataManager(data, new Query().take(7));
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'550px'}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//Sets layout type
type: 'HierarchicalTree',
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}}
//Sets the default properties for nodes and connectors
dataSourceSettings={{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}}
//Configures data source for diagram
getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
content: obj.data.Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 50;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.shape.margin = {
left: 25,
right: 25,
top: 25,
bottom: 25
};
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
NodeModel,
DiagramConstraints,
HierarchicalTree,
TextModel,
DataBinding,
Rect
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Kevin-Manager"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'550px'
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//Sets layout type
type: 'HierarchicalTree',
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}
}
//Sets the default properties for nodes and connectors
dataSourceSettings = {
{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}
}
//Configures data source for diagram
getNodeDefaults = {
(obj: NodeModel) => {
obj.shape = {
type: 'Text',
content: (obj.data as {
Name: 'string'
}).Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 50;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
(obj.shape as TextModel).margin = {
left: 25,
right: 25,
top: 25,
bottom: 25
};
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
The layout orientation can used to arrange the layout based on the direction. there are different orientation types that are defined in the following table.
Orientation | Description |
---|---|
TopToBottom | Aligns the layout from top to bottom. All the roots are placed at top of diagram. |
LeftToRight | Aligns the layout from left to right. All the roots are placed at left of diagram. |
BottomToTop | Aligns the layout from bottom to top. All the roots are placed at bottom of the diagram. |
RightToLeft | Aligns the layout from right to left. All the roots are placed at right of the diagram. |
Diagram provides support to customize the orientation
of layout. You can set the desired orientation using layout.orientation.
Note: In the diagram the default orientation is TopToBottom.
The following code illustrates how to arrange the nodes in a BottomToTop orientation.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, HierarchicalTree, DataBinding, Rect } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
{
Name: "Jim-CSE ",
ReportingPerson: "Kevin-Manager"
},
{
Name: "Martin-CSE",
ReportingPerson: "Kevin-Manager"
}
];
let items = new DataManager(data, new Query().take(7));
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'550px'}
//Uses layout to auto-arrange nodes on the diagram page
layout={{
//Sets layout type
type: 'HierarchicalTree',
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top',
orientation: 'BottomToTop'
}} dataSourceSettings={{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}}
//Sets the default properties for nodes and connectors
getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
content: obj.data.Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 50;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.shape.margin = {
left: 25,
right: 25,
top: 25,
bottom: 25
};
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
NodeModel,
DiagramConstraints,
HierarchicalTree,
TextModel,
DataBinding,
Rect
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
{
Name: "Jim-CSE ",
ReportingPerson: "Kevin-Manager"
},
{
Name: "Martin-CSE",
ReportingPerson: "Kevin-Manager"
}
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'550px'
}
//Uses layout to auto-arrange nodes on the diagram page
layout = {
{
//Sets layout type
type: 'HierarchicalTree',
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top',
orientation: 'BottomToTop'
}
}
dataSourceSettings = {
{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}
}
//Sets the default properties for nodes and connectors
getNodeDefaults = {
(obj: NodeModel) => {
obj.shape = {
type: 'Text',
content: (obj.data as {
Name: 'string'
}).Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 50;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
(obj.shape as TextModel).margin = {
left: 25,
right: 25,
top: 25,
bottom: 25
};
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
Layout provides support to arrange the nodes with reference to the position of a fixed node and set it to the fixedNode
of the layout property. This is helpful when you try to expand/collapse a node. It might be expected that the position of the double-clicked node should not be changed.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, HierarchicalTree, DataBinding, Rect } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
Name: "Steve-Ceo",
//set the offsetX and offsetY for the parent node
offsetX: 250,
offsetY: 50
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
{
Name: "Jim-CSE ",
ReportingPerson: "Kevin-Manager"
},
{
Name: "Martin-CSE",
ReportingPerson: "Kevin-Manager"
}
];
let items = new DataManager(data, new Query().take(7));
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'550px'}
//Defines default layout
layout={{
type: 'HierarchicalTree',
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}} dataSourceSettings={{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}}
//Sets the default properties of the node.
getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
content: obj.data.Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 50;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.shape.margin = {
left: 25,
right: 25,
top: 25,
bottom: 25
};
return obj;
}}
//Sets the default properties of the connector.
getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
NodeModel,
DiagramConstraints,
HierarchicalTree,
TextModel,
DataBinding,
Rect
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
Name: "Steve-Ceo",
//set the offsetX and offsetY for the parent node
offsetX: 250,
offsetY: 50
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "Peter-Manager",
ReportingPerson: "Steve-Ceo"
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager"
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager"
},
{
Name: "Jim-CSE ",
ReportingPerson: "Kevin-Manager"
},
{
Name: "Martin-CSE",
ReportingPerson: "Kevin-Manager"
}
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'550px'
}
//Defines default layout
layout = {
{
type: 'HierarchicalTree',
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}
}
dataSourceSettings = {
{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}
}
//Sets the default properties of the node.
getNodeDefaults = {
(obj: NodeModel) => {
obj.shape = {
type: 'Text',
content: (obj.data as {
Name: 'string'
}).Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 50;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
(obj.shape as TextModel).margin = {
left: 25,
right: 25,
top: 25,
bottom: 25
};
return obj;
}
}
//Sets the default properties of the connector.
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
Diagram allows to expand/collapse the subtrees of a layout. The node’s isExpanded property allows you to expand/collapse its children. The following code example shows how to expand/collapse the children of a node.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, HierarchicalTree, } from "@syncfusion/ej2-react-diagrams";
//Initializes data source
//let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
let diagramInstance;
let nodes = [{
id: 'node1',
width: 140,
height: 50,
isExpanded: false,
annotations: [{
content: 'node1'
}],
expandIcon: {
shape: 'Plus',
},
collapseIcon: {
shape: 'Minus',
}
},
{
id: 'node2',
width: 140,
height: 50,
annotations: [{
content: 'node2'
}],
},
{
id: 'node3',
width: 140,
height: 50,
annotations: [{
content: 'node3'
}],
}
];
let connectors = [{
// Name of the connector
id: "connector1",
// ID of the source and target nodes
sourceID: "node1",
targetID: "node2",
},
{
id: "connector2",
// ID of the source and target nodes
sourceID: "node2",
targetID: "node3",
}
];
ReactDOM.render(<DiagramComponent id="diagram" ref={diagram => (diagramInstance = diagram)} width={'1250px'} height={'590px'} nodes={nodes} connectors={connectors} snapSettings={{
constraints: 0
}} created={(args) => {
diagramInstance.fitToPage();
}} layout={{
// set enableAnimation as true
enableAnimation: true,
type: 'HierarchicalTree',
margin: {
top: 20
},
getLayoutInfo: (node, tree) => {
if (!tree.hasSubTree) {
tree.orientation = 'Vertical';
tree.type = 'Alternate';
}
}
}}
//Sets the default properties for nodes and connectors
getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
style: {
color: 'white'
}
};
obj.style = {
fill: '#6BA5D7',
strokeColor: 'none',
strokeWidth: 2
};
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.shape.margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}}><Inject services={[HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
Node,
SelectorConstraints,
HierarchicalTree,
} from "@syncfusion/ej2-react-diagrams";
import {
NodeModel,
} from "@syncfusion/ej2-react-diagrams";
//Initializes data source
//let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
let diagramInstance:Diagram
let nodes: NodeModel[] = [{
id: 'node1',
width: 140,
height: 50,
isExpanded:false,
annotations: [{
content: 'node1'
}],
expandIcon: {
shape: 'Plus',
},
collapseIcon: {
shape: 'Minus',
}
},
{
id: 'node2',
width: 140,
height: 50,
annotations: [{
content: 'node2'
}],
},
{
id: 'node3',
width: 140,
height: 50,
annotations: [{
content: 'node3'
}],
}
];
let connectors: ConnectorModel[] = [{
// Name of the connector
id: "connector1",
// ID of the source and target nodes
sourceID: "node1",
targetID: "node2",
},
{
id: "connector2",
// ID of the source and target nodes
sourceID: "node2",
targetID: "node3",
}
];
ReactDOM.render( <DiagramComponent id = "diagram" ref={diagram => (diagramInstance = diagram)}
width = {
'1250px'
}
height = {
'590px'
}
nodes = {
nodes
}
connectors = {
connectors
}
snapSettings = {
{
constraints: 0
}
}
created={(args) => {
diagramInstance.fitToPage();
}}
layout = {
{
// set enableAnimation as true
enableAnimation: true,
type: 'HierarchicalTree',
margin: {
top: 20
}, // define the getLayoutInfo
getLayoutInfo: (node: Node, tree: TreeInfo) => {
if (!tree.hasSubTree) {
tree.orientation = 'Vertical';
tree.type = 'Alternate';
}
}
}
}
//Sets the default properties for nodes and connectors
getNodeDefaults = {
(obj: Node) => {
obj.shape = {
type: 'Text',
style: {
color: 'white'
}
};
obj.style = {
fill: '#6BA5D7',
strokeColor: 'none',
strokeWidth: 2
};
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
(obj.shape as TextModel).margin = {
left: 5,
right: 5,
top: 5,
bottom: 5
};
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.type = 'Orthogonal';
return connector;
}
}
><Inject services = {[HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );
In the previous example, while expanding/collapsing a node, it is set as fixed node in order to prevent it from repositioning.
Diagram allows to refresh the layout at runtime. To refresh the layout, refer to Refresh layout.
The setNodeTemplate function is provided for the purpose of customizing nodes. It will be called for each node on node initialization. In this function, the node style and its properties can be customized and can bind the custom JSON with node.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, HierarchicalTree, DataBinding, Rect } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';
//Initializes data source
let data = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo",
color: 'darkcyan'
},
{
Name: "Peter-Manager",
ReportingPerson: "Steve-Ceo",
color: 'white'
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager",
color: 'darkcyan'
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager",
color: 'white'
},
{
Name: "Jim-CSE ",
ReportingPerson: "Kevin-Manager",
color: 'darkcyan'
},
{
Name: "Martin-CSE",
ReportingPerson: "Kevin-Manager",
color: 'white'
}
];
let items = new DataManager(data, new Query().take(7));
// Initializes the diagram
ReactDOM.render(<DiagramComponent id="diagram" width={'100%'} height={'550px'} layout={{
type: 'HierarchicalTree',
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}} dataSourceSettings={{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}} getNodeDefaults={(obj) => {
obj.shape = {
type: 'Text',
content: obj.data.Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 50;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
obj.shape.margin = {
left: 25,
right: 25,
top: 25,
bottom: 25
};
return obj;
}} getConnectorDefaults={(connector, diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.targetDecorator.shape = 'None';
connector.type = 'Orthogonal';
return connector;
}} setNodeTemplate={function (obj, diagram) {
obj.borderColor = obj.data.color;
}}><Inject services={[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
Diagram,
DiagramComponent,
Inject,
ConnectorModel,
NodeModel,
DiagramConstraints,
HierarchicalTree,
TextModel,
DataBinding,
Rect
} from "@syncfusion/ej2-react-diagrams";
import {
DataManager,
Query
} from '@syncfusion/ej2-data';
//Initializes data source
let data: object[] = [{
Name: "Steve-Ceo"
},
{
Name: "Kevin-Manager",
ReportingPerson: "Steve-Ceo",
color: 'darkcyan'
},
{
Name: "Peter-Manager",
ReportingPerson: "Steve-Ceo",
color: 'white'
},
{
Name: "John- Manager",
ReportingPerson: "Peter-Manager",
color: 'darkcyan'
},
{
Name: "Mary-CSE ",
ReportingPerson: "Peter-Manager",
color: 'white'
},
{
Name: "Jim-CSE ",
ReportingPerson: "Kevin-Manager",
color: 'darkcyan'
},
{
Name: "Martin-CSE",
ReportingPerson: "Kevin-Manager",
color: 'white'
}
];
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
// Initializes the diagram
ReactDOM.render( <DiagramComponent id = "diagram"
width = {
'100%'
}
height = {
'550px'
}
layout = {
{
type: 'HierarchicalTree',
bounds: new Rect(0, 0, 500, 500),
horizontalSpacing: 25,
verticalSpacing: 30,
horizontalAlignment: 'Left',
verticalAlignment: 'Top'
}
}
dataSourceSettings = {
{
id: 'Name',
parentId: 'ReportingPerson',
dataManager: items
}
}
getNodeDefaults = {
(obj: NodeModel) => {
obj.shape = {
type: 'Text',
content: (obj.data as {
Name: 'string'
}).Name
};
obj.style = {
fill: 'None',
strokeColor: 'none',
strokeWidth: 2,
bold: true,
color: 'white'
};
obj.width = 50;
obj.height = 40;
obj.borderColor = 'white';
obj.backgroundColor = '#6BA5D7';
obj.borderWidth = 1;
(obj.shape as TextModel).margin = {
left: 25,
right: 25,
top: 25,
bottom: 25
};
return obj;
}
}
getConnectorDefaults = {
(connector: ConnectorModel, diagram: Diagram) => {
connector.style = {
strokeColor: '#6BA5D7',
strokeWidth: 2
};
connector.targetDecorator.style.fill = '#6BA5D7';
connector.targetDecorator.style.strokeColor = '#6BA5D7';
connector.targetDecorator.shape = 'None';
connector.type = 'Orthogonal';
return connector;
}
}
setNodeTemplate = {
function(obj:NodeModel, diagram:Diagram) {
obj.borderColor = (obj.data as {
color: 'string'
}).color;
}
}
><Inject services = {[DataBinding, HierarchicalTree]}/>
</DiagramComponent>, document.getElementById("diagram") );

Automatic layout in Vue Diagram component

31 Jan 202424 minutes to read

Diagram provides support to auto-arrange the nodes in the diagram area that is referred as Layout. It includes the following layout modes:

Layout modes

  • Hierarchical layout
  • Organization chart
  • Radial tree
  • Symmetric layout
  • Mind Map layout
  • Complex hierarchical tree layout

Hierarchical layout

The hierarchical tree layout arranges nodes in a tree-like structure, where the nodes in the hierarchical layout may have multiple parents. There is no need to specify the layout root. To arrange the nodes in a hierarchical structure, specify the layout type as hierarchical tree. The following example shows how to arrange the nodes in a hierarchical structure.

Note: If you want to use hierarchical tree layout in diagram, you need to inject HierarchicalTree in the diagram.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin,Diagram, HierarchicalTree,HierarchicalTree, DataBinding,DiagramTools,NodeModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, HierarchicalTree);
    Vue.use(DiagramPlugin);
    export let data = [{
        Name: "Steve-Ceo"
    },
    {
        Name: "Kevin-Manager",
        ReportingPerson: "Steve-Ceo"
    },
    {
        Name: "Peter-Manager",
        ReportingPerson: "Steve-Ceo"
    },
    {
        Name: "John- Manager",
        ReportingPerson: "Peter-Manager"
    },
    {
        Name: "Mary-CSE ",
        ReportingPerson: "Peter-Manager"
    },
    {
        Name: "Jim-CSE ",
        ReportingPerson: "Kevin-Manager"
    },
    {
        Name: "Martin-CSE",
        ReportingPerson: "Kevin-Manager"
    }];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "350px",
                //Uses layout to auto-arrange nodes on the Diagram page
                layout: {
                    //Sets layout type
                    type: 'HierarchicalTree'
                },
                dataSourceSettings: {
                    id: 'Name',
                    parentId: 'ReportingPerson',
                    dataManager: items
                },
                getNodeDefaults: (obj) => {
                    obj.shape = {
                        type: 'Text',
                        content: (obj.data as {
                            Name: 'string'
                        }).Name
                    };
                    obj.style = {
                        fill: 'None',
                        strokeColor: 'none',
                        strokeWidth: 2,
                        bold: true,
                        color: 'white'
                    };
                    obj.borderColor = 'white';
                    obj.width = 100;
                    obj.height = 40;
                    obj.backgroundColor = '#6BA5D7';
                    obj.borderWidth = 1;
                    (obj.shape as TextModel).margin = {
                        left: 5,
                        right: 5,
                        top: 5,
                        bottom: 5
                    };
                    return obj;
                },
                getConnectorDefaults: (connector) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.type = 'Orthogonal';
                    return connector;
                },
            }
        },
        provide: {
            diagram: [DataBinding, HierarchicalTree]
        },
    }
</script>
<style>
    @import "https://ej2.syncfusion.com/vue/documentation/../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Radial tree layout

The radial tree layout arranges nodes on a virtual concentric circle around a root node. Sub-trees formed by the branching of child nodes are located radially around the child nodes. This arrangement result in an ever-expanding concentric arrangement with radial proximity to the root node indicating the node level in the hierarchy. The layout root property can be used to define the root node of the layout. When no root node is set, the algorithm automatically considers one of the diagram nodes as the root node.

To arrange nodes in a radial tree structure, set the type of the layout as RadialTree. The following code illustrates how to arrange the nodes in a radial tree structure.

Note: If you want to use radial tree layout in diagram, you need to inject DataBinding and RadialTree in the diagram.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults' :snapSettings='snapSettings' :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin,Diagram, HierarchicalTree,RadialTree, DataBinding,DiagramTools,NodeModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, RadialTree);
    Vue.use(DiagramPlugin);
    export let data = [{
        "Id": 1,
        "Name": "Ana Trujillo",
        "Designation": "Project Manager",
        "RatingColor": "#68C2DE"
    },
    {
        "Id": 2,
        "Name": "Lino Rodri",
        "Designation": "Project Manager",
        "RatingColor": "#68C2DE",
        "ReportingPerson": 1
    },
    {
        "Id": 3,
        "Name": "Philip Cramer",
        "Designation": "Project Manager",
        "RatingColor": "#68C2DE",
        "ReportingPerson": 1
    },
    {
        "Id": 4,
        "Name": "Pedro Afonso",
        "Designation": "Project Manager",
        "RatingColor": "#68C2DE",
        "ReportingPerson": 1
    },
    {
        "Id": 5,
        "Name": "Anto Moreno",
        "Designation": "Project Lead",
        "RatingColor": "#93B85A",
        "ReportingPerson": 1
    },
    {
        "Id": 6,
        "Name": "Elizabeth Roel",
        "Designation": "Project Lead",
        "RatingColor": "#93B85A",
        "ReportingPerson": 1
    },
    {
        "Id": 7,
        "Name": "Aria Cruz",
        "Designation": "Project Lead",
        "RatingColor": "#93B85A",
        "ReportingPerson": 1
    },
    {
        "Id": 8,
        "Name": "Eduardo Roel",
        "Designation": "Project Lead",
        "RatingColor": "#93B85A",
        "ReportingPerson": 1
    },
    {
        "Id": 9,
        "Name": "Howard Snyd",
        "Designation": "Project Lead",
        "RatingColor": "#68C2DE",
        "ReportingPerson": 1
    },
    {
        "Id": 10,
        "Name": "Daniel Tonini",
        "Designation": "Project Lead",
        "RatingColor": "#93B85A",
        "ReportingPerson": 1
    },
    {
        "Id": 11,
        "Name": "Nardo Batista",
        "Designation": "Project Lead",
        "RatingColor": "#68C2DE",
        "ReportingPerson": 1
    }
];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(5));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "590px",
                snapSettings: {
                    constraints: 0
                },
                //Uses layout to auto-arrange nodes on the Diagram page
                layout: {
                    //set the type as Radial Tree
                    type: 'RadialTree',
                    root: 'parent'
                },
                //Configures data source for Diagram
                dataSourceSettings: {
                    id: 'Id',
                    parentId: 'ReportingPerson',
                    dataManager: items
                },
                //Sets the default properties for nodes and connectors
                getNodeDefaults: (obj: Node, diagram: Diagram) => {
                    obj.height = 15;
                    obj.width = 15;
                    obj.borderWidth = 1;
                    obj.style = {
                        fill: '#6BA5D7',
                        strokeWidth: 2,
                        strokeColor: '#6BA5D7'
                    };
                    return obj;
                },
                getConnectorDefaults: (connector: ConnectorModel, diagram: Diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.targetDecorator.shape = 'None';
                    connector.type = 'Straight';
                    return connector;
                },
            }
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Organizational Chart

An organizational chart is a diagram that displays the structure of an organization and relationships. To create an organizational chart, the type of layout should be set as an OrganizationalChart.

The following code example illustrates how to create an organizational chart.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'  :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin,Diagram, HierarchicalTree, DataBinding,DiagramTools,NodeModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, HierarchicalTree);
    Vue.use(DiagramPlugin);
    export let data = [{
        Id: "parent",
        Role: "Project Management"
    },
    {
        Id: 1,
        Role: "R&D Team",
        Team: "parent"
    },
    {
        Id: 3,
        Role: "Philosophy",
        Team: "1"
    },
    {
        Id: 4,
        Role: "Organization",
        Team: "1"
    },
    {
        Id: 5,
        Role: "Technology",
        Team: "1"
    },
    {
        Id: 7,
        Role: "Funding",
        Team: "1"
    },
    {
        Id: 8,
        Role: "Resource Allocation",
        Team: "1"
    },
    {
        Id: 9,
        Role: "Targeting",
        Team: "1"
    },
    {
        Id: 11,
        Role: "Evaluation",
        Team: "1"
    },
    {
        Id: 156,
        Role: "HR Team",
        Team: "parent"
    },
    {
        Id: 13,
        Role: "Recruitment",
        Team: "156"
    },
    {
        Id: 113,
        Role: "Training",
        Team: "12"
    },
    {
        Id: 112,
        Role: "Employee Relation",
        Team: "156"
    },
    {
        Id: 14,
        Role: "Record Keeping",
        Team: "12"
    },
    {
        Id: 15,
        Role: "Compensations & Benefits",
        Team: "12"
    },
    {
        Id: 16,
        Role: "Compliances",
        Team: "12"
    },
    {
        Id: 17,
        Role: "Production & Sales Team",
        Team: "parent"
    },
    {
        Id: 119,
        Role: "Design",
        Team: "17"
    },
    {
        Id: 19,
        Role: "Operation",
        Team: "17"
    },
    {
        Id: 20,
        Role: "Support",
        Team: "17"
    },
    {
        Id: 21,
        Role: "Quality Assurance",
        Team: "17"
    },
    {
        Id: 23,
        Role: "Customer Interaction",
        Team: "17"
    },
    {
        Id: 24,
        Role: "Support and Maintenance",
        Team: "17"
    },
    {
        Id: 25,
        Role: "Task Coordination",
        Team: "17"
    }
];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(5));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "590px",
                //Uses layout to auto-arrange nodes on the Diagram page
                layout: {
                    //set the type as Organizational Chart
                    type: 'OrganizationalChart'
                }, //Configures data source for Diagram
                dataSourceSettings: {
                    id: 'Id',
                    parentId: 'Team',
                    dataManager: items
                }, //Sets the default properties for nodes and connectors
                getNodeDefaults: (obj: NodeModel) => {
                    obj.shape = {
                        type: 'Text',
                        content: (obj.data as {
                            Role: 'string'
                        }).Role
                    };
                    obj.style = {
                        fill: 'None',
                        strokeColor: 'none',
                        strokeWidth: 2,
                        bold: true,
                        color: 'white'
                    };
                    obj.borderColor = 'white';
                    obj.backgroundColor = '#6BA5D7';
                    obj.borderWidth = 1;
                    obj.width = 75;
                    obj.height = 40;
                    (obj.shape as TextModel).margin = {
                        left: 5,
                        right: 5,
                        top: 5,
                        bottom: 5
                    };
                    return obj;
                },
                getConnectorDefaults: (connector: ConnectorModel, diagram: Diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Organizational chart layout starts parsing from root and iterate through all its child elements. The getLayoutInfo method provides necessary information of a node’s children and the way to arrange (direction, orientation, offsets, etc.) them. The arrangements can be customized by overriding this function as explained.

GetLayoutInfo
Set chart orientations, chart types, and offset to be left between parent and child nodes by overriding the method, diagram.layout.getLayoutInfo. The getLayoutInfo method is called to configure every subtree of the organizational chart. It takes the following arguments.

* node: Parent node to that options are to be customized.
* options: Object to set the customizable properties.
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'  :snapSettings='snapSettings':getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin,Diagram, HierarchicalTree, DataBinding,DiagramTools,NodeModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, HierarchicalTree);
    Vue.use(DiagramPlugin);
    export let data = [{
        Id: 1,
        Role: "General Manager"
    },
    {
        Id: 2,
        Role: "Assistant Manager",
        Team: 1
    },
    {
        Id: 3,
        Role: "Human Resource Manager",
        Team: 1
    },
    {
        Id: 4,
        Role: "Design Manager",
        Team: 1
    },
    {
        Id: 5,
        Role: "Operation Manager",
        Team: 1
    },
    {
        Id: 6,
        Role: "Marketing Manager",
        Team: 1
    }];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "590px",
                //Uses layout to auto-arrange nodes on the Diagram page
                snapSettings: {
                    constraints: 0
                }, //Uses layout to auto-arrange nodes on the Diagram page
                layout: {
                    //Sets layout type
                    type: 'OrganizationalChart',
                    getLayoutInfo: (node: Node, options: TreeInfo) => {
                        if (!options.hasSubTree) {
                            options.type = 'Center';
                            options.orientation = 'Horizontal';
                        }
                    }
                }, //Configures data source for Diagram
                dataSourceSettings: {
                    id: 'Id',
                    parentId: 'Team',
                    dataManager: items
                },
                //Sets the default properties for nodes and connectors
                getNodeDefaults: (obj: Node, diagram: Diagram) => {
                    obj.width = 150;
                    obj.height = 50;
                    obj.style.fill = '#6BA5D7';
                    obj.annotations = [{
                        content: obj.data['Role'],
                        style: {
                            color: 'white'
                        }
                    }];
                    return obj;
                },
                getConnectorDefaults: (connector: ConnectorModel, diagram: Diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.targetDecorator.shape = 'None';
                    connector.targetDecorator.shape = 'None';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

The following table illustrates the properties that “options” argument takes.

Property Description Default Value
options.assistants By default, the collection is empty. When any of the child nodes have to be set asAssistant, you can remove from children collection and have to insert into assistants collection. Empty array
options.orientation Gets or sets the organizational chart orientation. SubTreeOrientation.Vertical
options.type Gets or sets the chart organizational chart type. For horizontal chart orientation:SubTreeAlignments.Center and for vertical chart orientation:SubTreeAlignments.Alternate
options.offset Offset is the horizontal space to be left between parent and child nodes. 20 pixels applicable only for vertical chart orientations.
options.hasSubTree Gets whether the node contains subtrees. Boolean
options.level Gets the depth of the node from layout root. Number
options.enableRouting By default, connections are routed based on the chart type and orientations. This property gets or sets whether default routing is to be enabled or disabled. true
options.rows Sets the number of rows on which the child nodes will be arranged. Applicable only for balanced type horizontal tree. Number

The following table illustrates the different chart orientations and chart types.

Orientation Type Description Example
Horizontal Left Arranges the child nodes horizontally at the left side of the parent. Horizontal Left
Right Arranges the child nodes horizontally at the right side of the parent. Horizontal Right  
Center Arranges the children like standard tree layout orientation. Horizontal Center  
Balanced Arranges the leaf level child nodes in multiple rows. Horizontal Balanced  
Vertical Left Arranges the children vertically at the left side of the parent. Vertical Left
Right Arranges the children vertically at the right side of the parent. Vertical Right  
Alternate Arranges the children vertically at both left and right sides of the parent. Vertical Alternate  

The following code example illustrates how to set the vertical right arrangement to the leaf level trees.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'  :snapSettings='snapSettings':getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin,Diagram, HierarchicalTree, DataBinding,TreeInfo,NodeModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, HierarchicalTree);
    Vue.use(DiagramPlugin);
    export let data = [{
        Id: "parent",
        Role: "Board"
    },
    {
        Id: "1",
        Role: "General Manager",
        Manager: "parent"
    },
    {
        Id: "2",
        Role: "Human Resource Manager",
        Manager: "1"
    },
    {
        Id: "3",
        Role: "Trainers",
        Manager: "2"
    },
    {
        Id: "4",
        Role: "Recruiting Team",
        Manager: "2"
    },
    {
        Id: "6",
        Role: "Design Manager",
        Manager: "1"
    },
    {
        Id: "7",
        Role: "Design Supervisor",
        Manager: "6"
    },
    {
        Id: "8",
        Role: "Development Supervisor",
        Manager: "6"
    },
    {
        Id: "9",
        Role: "Drafting Supervisor",
        Manager: "6"
    },
    {
        Id: "10",
        Role: "Marketing Manager",
        Manager: "1"
    },
    {
        Id: "11",
        Role: "Oversea sales Manager",
        Manager: "10"
    },
    {
        Id: "12",
        Role: "Petroleum Manager",
        Manager: "10"
    },
    {
        Id: "13",
        Role: "Service Dept. Manager",
        Manager: "10"
    }];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "590px",
                //Uses layout to auto-arrange nodes on the Diagram page
                snapSettings: {
                    constraints: 0
                }, //Uses layout to auto-arrange nodes on the Diagram page
                layout: {
                    //Sets layout type
                    type: 'OrganizationalChart',
                    //Defines getLayoutInfo
                    getLayoutInfo: (node: Node, options: TreeInfo) => {
                        if (node.data['Role'] === 'General Manager') {
                            options.assistants.push(options.children[0]);
                            options.children.splice(0, 1);
                        }
                        if (!options.hasSubTree) {
                            options.type = 'Right';
                            options.orientation = 'Vertical';
                        }
                    }
                }, //Configures data source for Diagram
                dataSourceSettings: {
                    id: 'Id',
                    parentId: 'Manager',
                    dataManager: items
                }, //Sets the default properties for nodes and connectors
                getNodeDefaults: (obj: Node, diagram: Diagram) => {
                    obj.width = 150;
                    obj.height = 50;
                    obj.borderColor = 'white';
                    obj.style.fill = '#6BA5D7';
                    obj.borderWidth = 1;
                    obj.annotations = [{
                        content: obj.data['Role'],
                        style: {
                            color: 'white'
                        }
                    }];
                    return obj;
                },
                getConnectorDefaults: (connector: ConnectorModel, diagram: Diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill = '#6BA5D7';
                    connector.targetDecorator.style.strokeColor = '#6BA5D7';
                    connector.targetDecorator.shape = 'None';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Assistant

Assistants are child item that have a different relationship with the parent node. They are laid out in a dedicated part of the tree. A node can be specified as an assistant of its parent by adding it to the assistants property of the argument “options”.

The following code example illustrates how to add assistants to layout.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'  :snapSettings='snapSettings':getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin,Diagram, HierarchicalTree, DataBinding,TreeInfo,NodeModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, HierarchicalTree);
    Vue.use(DiagramPlugin);
    export let data = [{
        Id: 1,
        Role: "General Manager"
    },
    {
        Id: 2,
        Role: "Assistant Manager",
        Team: 1
    },
    {
        Id: 3,
        Role: "Human Resource Manager",
        Team: 1
    },
    {
        Id: 4,
        Role: "Design Manager",
        Team: 1
    },
    {
        Id: 5,
        Role: "Operation Manager",
        Team: 1
    },
    {
        Id: 6,
        Role: "Marketing Manager",
        Team: 1
    }];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "590px",
                snapSettings: {
                    constraints: 0
                }, //Uses layout to auto-arrange nodes on the Diagram page
                layout: {
                    //Sets layout type
                    type: 'OrganizationalChart',
                    // define the getLayoutInfo
                    getLayoutInfo: (node: Node, options: TreeInfo) => {
                        if (node.data['Role'] === 'General Manager') {
                            options.assistants.push(options.children[0]);
                            options.children.splice(0, 1);
                        }
                        if (!options.hasSubTree) {
                            options.type = 'Center';
                            options.orientation = 'Horizontal';
                        }
                    }
                }, //Initializes the node template.
                dataSourceSettings: {
                    id: 'Id',
                    parentId: 'Team',
                    dataManager: items
                },
                //Sets the default properties for nodes and connectors
                getNodeDefaults: (obj: Node, diagram: Diagram) => {
                    obj.width = 150;
                    obj.height = 50;
                    obj.borderColor = 'white';
                    obj.style.fill = '#6BA5D7';
                    obj.borderWidth = 1;
                    obj.annotations = [{
                        content: obj.data['Role'],
                        style: {
                            color: 'white'
                        }
                    }];
                    return obj;
                },
                getConnectorDefaults: (connector: ConnectorModel, diagram: Diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.targetDecorator.shape = 'None';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Symmetric layout

The symmetric layout has been formed using nodes position by closer together or pushing them further apart. This is repeated iteratively until the system comes to an equilibrium state.

The layout’s springLength defined as how long edges should be, ideally. This will be the resting length for the springs. Edge attraction and vertex repulsion forces to be defined by using layout’s springFactor, the more sibling nodes repel each other. The relative positions do not change any more from one iteration to the next. The number of iterations can be specified by using layout’s maxIteration.

The following code illustrates how to arrange the nodes in a radial tree structure.

Note: If you want to use symmetric layout in diagram, you need to inject SymmetricLayout in the diagram.

Mind Map layout

A mind map is a diagram that displays the nodes as a spider diagram organizes information around a central concept. To create mind map, the type of layout should be set as MindMap.

Tree Orientation in layout

An Orientation of a MindMapTreeLayout is used to arrange the tree layout according to a specific direction. By default, the orientation is set to Horizontal. The following table outlines the various orientation types available:

Orientation Type Description
Horizontal Aligns the tree layout from left to right
Vertical Aligns the tree layout from top to bottom

NOTE

If you want to use mind map layout in diagram, you need to inject MindMap in the diagram.

The following code example illustrates how to create an mindmap layout.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'  :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin,Diagram, MindMap, DataBinding,TreeInfo,NodeModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, MindMap);
    Vue.use(DiagramPlugin);
    export let data = [{
        id: 1,
        Label: 'StackPanel'
    },
    {
        id: 2,
        Label: 'Label',
        parentId: 1
    },
    {
        id: 3,
        Label: 'ListBox',
        parentId: 1
    },
    {
        id: 4,
        Label: 'StackPanel',
        parentId: 2
    },
    {
        id: 5,
        Label: 'Border',
        parentId: 2
    },
    {
        id: 6,
        Label: 'Border',
        parentId: 4
    },
    {
        id: 7,
        Label: 'Button',
        parentId: 4
    },
    {
        id: 8,
        Label: 'ContentPresenter',
        parentId: 5
    },
    {
        id: 9,
        Label: 'Text Block',
        parentId: 5
    }];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "590px",
                layout: {
                    //Sets layout type
                    type: 'MindMap',
                    orientation: 'Horizontal'
                }, //Configures data source for Diagram
                dataSourceSettings: {
                    id: 'id',
                    parentId: 'parentId',
                    dataManager: items,
                    root: String(1)
                }, //Sets the default properties for nodes and connectors
                getNodeDefaults: (obj: Node) => {
                    obj.shape = {
                        type: 'Text',
                        content: (obj.data as {
                            Label: 'string'
                        }).Label,
                    };
                    obj.style = {
                        fill: '#6BA5D7',
                        strokeColor: 'none',
                        strokeWidth: 2
                    };
                    obj.borderColor = 'white';
                    obj.backgroundColor = '#6BA5D7';
                    obj.borderWidth = 1;
                    (obj.shape as TextModel).margin = {
                        left: 5,
                        right: 5,
                        top: 5,
                        bottom: 5
                    };
                    return obj;
                },
                getConnectorDefaults: (connector: ConnectorModel, diagram: Diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill = '#6BA5D7';
                    connector.targetDecorator.style.strokeColor = '#6BA5D7';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Complex hierarchical tree

Complex hierarchical tree layout is the extended version of the hierarchical tree layout. The child had been two or more parents. To create a complex hierarchical tree, the type of layout should be set as ComplexHierarchicalTree.

Note: If you want to use Complex hierarchical layout in diagram, you need to inject ComplexHierarchicalTree in the diagram.

The following code example illustrates how to create a complex hierarchical tree.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height'  :nodes='nodes' :connectors='connectors'
        :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin,Diagram,DataBinding, ConnectorModel, NodeModel, DiagramConstraints, ComplexHierarchicalTree } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, ComplexHierarchicalTree);
    Vue.use(DiagramPlugin);
    let nodes = [{
        id: 'node1',
        width: 70,
        height: 70,
        annotations: [{
            content: 'node1'
        }]
    },
    {
        id: 'node2',
        width: 70,
        height: 70,
        annotations: [{
            content: 'node2'
        }]
    },
    {
        id: 'node3',
        width: 70,
        height: 70,
        annotations: [{
            content: 'node3'
        }]
    },
    {
        id: 'node4',
        width: 70,
        height: 70,
        annotations: [{
            content: 'node4'
        }]
    },
    {
        id: 'node5',
        width: 70,
        height: 70,
        annotations: [{
            content: 'node5'
        }]
    },
    {
        id: 'node8',
        width: 70,
        height: 70,
        annotations: [{
            content: 'node8'
        }]
    },
    {
        id: 'node9',
        width: 70,
        height: 70,
        annotations: [{
            content: 'node9'
        }]
    }]
    let connectors = [
        {
        id: 'connectr',
        sourceID: 'node1',
        targetID: 'node4'
    },
    {
        id: 'connectr1',
        sourceID: 'node2',
        targetID: 'node4'
    },
    {
        id: 'connectr3',
        sourceID: 'node3',
        targetID: 'node4'
    },
    {
        id: 'connectr4',
        sourceID: 'node4',
        targetID: 'node5'
    }
        ]
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "590px",
                nodes: nodes,
                    connectors: connectors,
                    getNodeDefaults: (obj: Node) => {
            obj.shape = {
                type: 'Text',
                style: {
                    color: 'white';
                }
            };
            obj.style = {
                fill: '#6BA5D7',
                strokeColor: 'none',
                strokeWidth: 2
            };
            obj.borderColor = 'white';
            obj.backgroundColor = '#6BA5D7';
            obj.borderWidth = 1;
            (obj.shape as TextModel).margin = {
                left: 5,
                right: 5,
                top: 5,
                bottom: 5
            };
            return obj;
        },
                getConnectorDefaults: (connector: ConnectorModel, diagram: Diagram) => {
            connector.style = {
                strokeColor: '#6BA5D7',
                strokeWidth: 2
            };
            connector.targetDecorator.style.fill = '#6BA5D7';
            connector.targetDecorator.style.strokeColor = '#6BA5D7';
            connector.type = 'Orthogonal';
            return connector;
        },
                layout: {
            //Sets layout type
                type: 'ComplexHierarchicalTree',
                orientation: 'TopToBottom'
            },
            }
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Line Distribution

Line distribution is used to arrange the connectors without overlapping in automatic layout. In some cases, the automatic layout connectors connecting to the nodes will be overlapped with one another. So user can decide whether the segment of each connector from a single parent node should be same point or different point. The connectionPointOrigin property of layout is used to enable or disable the line distribution in layout. By default connectionPointOrigin will be SamePoint.

The following code example illustrates how to create a complex hierarchical tree with line distribution.

Note: If you want to use line distribution in diagram layout, you need to inject LineDistribution module in the diagram.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin, Diagram, ComplexHierarchicalTree, DataBinding, LineDistribution, NodeModel, ConnectionPointOrigin, ConnectorModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, ComplexHierarchicalTree, LineDistribution);
    Vue.use(DiagramPlugin);
    export let data = [
        { "Name": "node11" },
        { "Name": "node12", "ReportingPerson": ["node114"] },
        { "Name": "node13", "ReportingPerson": ["node12"] },
        { "Name": "node14", "ReportingPerson": ["node12"] },
        { "Name": "node15", "ReportingPerson": ["node12"] },
        { "Name": "node116", "ReportingPerson": ["node22","node12"] },
        { "Name": "node16", "ReportingPerson": [] },
        { "Name": "node18", "ReportingPerson": [] },
        { "Name": "node21" },
        { "Name": "node22", "ReportingPerson": ["node114"] },
        { "Name": "node23", "ReportingPerson": ["node22"] },
        { "Name": "node24", "ReportingPerson": ["node22"] },
        { "Name": "node25", "ReportingPerson": ["node22"] },
        { "Name": "node26", "ReportingPerson": [] },
        { "Name": "node28", "ReportingPerson": [] },
        { "Name": "node31" },
        { "Name": "node114", "ReportingPerson": ["node11", "node21", "node31"]}
];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "590px",
                //Uses layout to auto-arrange nodes on the Diagram page
                layout: {
                    type: 'ComplexHierarchicalTree',
                    connectionPointOrigin: ConnectionPointOrigin.DifferentPoint,
                    horizontalSpacing: 40, verticalSpacing: 40, horizontalAlignment: "Left", verticalAlignment: "Top",
                    margin: { left: 0, right: 0, top: 0, bottom: 0 },
                    orientation: 'TopToBottom'
                },
                dataSourceSettings: {
                    id: 'Name',
                    parentId: 'ReportingPerson',
                    dataManager: items
                },
                getNodeDefaults: (obj) => {
                    obj.width = 40; obj.height = 40;
                    obj.shape = { type: 'Basic', shape: 'Rectangle', cornerRadius: 7 };
                    obj.style = { fill: '#6BA5D7', strokeColor: 'none', strokeWidth: 2 };
                    obj.borderWidth = 1;
                    obj.backgroundColor = '#6BA5D7';
                    return obj;
                },
                getConnectorDefaults: (connector) => {
                    connector.type = 'Orthogonal';
                    connector.cornerRadius = 7;
                    connector.targetDecorator.height = 7;
                    connector.targetDecorator.width = 7;
                    connector.style = { strokeColor: '#6BA5D7', strokeWidth: 1 };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    return connector;
                },
            }
        },
        mounted: function() {
            let diagramInstance: Diagram;
            let diagramObj: any = document.getElementById("diagram");
            diagramInstance = diagramObj.ej2_instances[0];
            diagramInstance.fitToPage({
                mode: 'Width',
            });
        }
        provide: {
            diagram: [DataBinding, ComplexHierarchicalTree, LineDistribution]
        },
    }
</script>
<style>
    @import "https://ej2.syncfusion.com/vue/documentation/../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Linear Arrangement

Linear arrangement is used to linearly arrange the child nodes in layout, which means the parent node is placed in the center corresponding to its children. When line distribution is enabled, linear arrangement is also activated by default. The arrangement property of layout is used to enable or disable the linear arrangement in layout. By default arrangement will be Nonlinear.

Note: If you want to use linear arrangement in diagram layout, you need to inject LineDistribution module in the diagram. Linear arrangement is applicable only for complex hierarchical tree layout.

The following code illustrates how to allow a linear arrangement in diagram layout.


export default {
    name: 'app',
    data() {
        return {
            width: "100%",
            height: "590px",
            layout: {
                type: 'ComplexHierarchicalTree',
                //To arrange a child nodes in a linear manner
                arrangement: ChildArrangement.Linear,
                horizontalSpacing: 40, verticalSpacing: 40,
                orientation: 'TopToBottom'
            },
        }
    },
    provide: {
        diagram: [DataBinding, ComplexHierarchicalTree, LineDistribution]
    },
}

Prevent connectors overlay

The below constraints prevents the connector segments overlapping nodes with a complex hierarchical layout.


export default {
    name: 'app',
    data() {
        return {
            width: "100%",
            height: "590px",
            layout: {
                //this prevents connector segments overlapping
                enableRouting: true
            },
        }
    },
    provide: {
        diagram: [DataBinding, ComplexHierarchicalTree, LineDistribution]
    },
}

Customize layout

Orientation, spacings, and position of the layout can be customized with a set of properties.

To explore layout properties, refer to Layout Properties.

Layout bounds

Diagram provides support to align the layout within any custom rectangular area. For more information about bounds, refer to bounds.

Layout alignment

The layout can be aligned anywhere over the layout bounds/viewport using the horizontalAlignment andverticalAlignment properties of the layout.

The following code illustrates how to align the layout at the top-left of the layout bounds.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height'  :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin, HierarchicalTree, DataBinding,Diagram,Rect } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, HierarchicalTree);
    Vue.use(DiagramPlugin);
    let data: object[] = [{
        Name: "Steve-Ceo"
    },
    {
        Name: "Kevin-Manager",
        ReportingPerson: "Steve-Ceo"
    },
    {
        Name: "Peter-Manager",
        ReportingPerson: "Kevin-Manager"
    },
    {
        Name: "John- Manager",
        ReportingPerson: "Peter-Manager"
    },
    {
        Name: "Mary-CSE ",
        ReportingPerson: "Peter-Manager"
    },
];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "350px",
                layout: {
                    //Sets layout type
                    type: 'HierarchicalTree',
                    //set layout alignment
                    bounds: new Rect(0, 0, 500, 500),
                    horizontalSpacing: 25,
                    verticalSpacing: 30,
                    horizontalAlignment: 'Left',
                    verticalAlignment: 'Top'
                },
                dataSourceSettings: {
                    id: 'Name',
                    parentId: 'ReportingPerson',
                    dataManager: items
                },
                getNodeDefaults: (obj: Node) => {
                    obj.shape = {
                        type: 'Text',
                        content: (obj.data as {
                            Name: 'string'
                        }).Name
                    };
                    obj.style = {
                        fill: 'None',
                        strokeColor: 'none',
                        strokeWidth: 2,
                        bold: true,
                        color: 'white'
                    };
                    obj.width = 100;
                    obj.height = 40;
                    obj.borderColor = 'white';
                    obj.backgroundColor = '#6BA5D7';
                    obj.borderWidth = 1;
                    return obj;
                },
                getConnectorDefaults: (connector, diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
        provide: {
            diagram: [DataBinding, HierarchicalTree]
        },
    }
</script>
<style>
    @import "https://ej2.syncfusion.com/vue/documentation/../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Layout spacing

Layout provides support to add space horizontally and vertically between the nodes. The horizontalSpacing and verticalSpacing properties of the layout allows you to set the space between the nodes in horizontally and vertically.

Layout margin

Layout provides support to add some blank space between the layout bounds/viewport and the layout. The margin property of the layout allows you to set the blank space.

The following code illustrates how to set the layout margin.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height'  :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin, HierarchicalTree, DataBinding,Diagram,Rect } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, HierarchicalTree);
    Vue.use(DiagramPlugin);
    let data: object[] = [{
        Name: "Steve-Ceo"
    },
    {
        Name: "Kevin-Manager",
        ReportingPerson: "Steve-Ceo"
    },
    {
        Name: "Peter-Manager",
        ReportingPerson: "Kevin-Manager"
    },
    {
        Name: "John- Manager",
        ReportingPerson: "Peter-Manager"
    },
    {
        Name: "Mary-CSE ",
        ReportingPerson: "Peter-Manager"
    },];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "350px",
                layout: {
                    //Sets layout type
                    type: 'HierarchicalTree',
                    bounds: new Rect(0, 0, 500, 500),
                    horizontalSpacing: 25,
                    verticalSpacing: 30,
                    horizontalAlignment: 'Left',
                    verticalAlignment: 'Top'
                },
                dataSourceSettings: {
                    id: 'Name',
                    parentId: 'ReportingPerson',
                    dataManager: items
                },
                getNodeDefaults: (obj: Node) => {
                    obj.shape = {
                        type: 'Text',
                        content: (obj.data as {
                            Name: 'string'
                        }).Name
                    };
                    obj.style = {
                        fill: 'None',
                        strokeColor: 'none',
                        strokeWidth: 2,
                        bold: true,
                        color: 'white'
                    };
                    obj.width = 100;
                    obj.height = 40;
                    obj.borderColor = 'white';
                    obj.backgroundColor = '#6BA5D7';
                    obj.borderWidth = 1;
                    return obj;
                },
                getConnectorDefaults: (connector, diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
        provide: {
            diagram: [DataBinding, HierarchicalTree]
        },
    }
</script>
<style>
    @import "https://ej2.syncfusion.com/vue/documentation/../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Layout orientation

The layout orientation can used to arrange the layout based on the direction. there are different orientation types that are defined in the following table.

Orientation Description
TopToBottom Aligns the layout from top to bottom. All the roots are placed at top of diagram.
LeftToRight Aligns the layout from left to right. All the roots are placed at left of diagram.
BottomToTop Aligns the layout from bottom to top. All the roots are placed at bottom of the diagram.
RightToLeft Aligns the layout from right to left. All the roots are placed at right of the diagram.

Diagram provides support to customize the orientation of layout. You can set the desired orientation using layout.orientation.

Note: In the diagram the default orientation is TopToBottom.

The following code illustrates how to arrange the nodes in a BottomToTop orientation.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height'  :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin, HierarchicalTree, DataBinding,Diagram,Rect } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, HierarchicalTree);
    Vue.use(DiagramPlugin);
    let data: object[] = [{
        Name: "Steve-Ceo"
    },
    {
        Name: "Kevin-Manager",
        ReportingPerson: "Steve-Ceo"
    },
    {
        Name: "Peter-Manager",
        ReportingPerson: "Kevin-Manager"
    },
    {
        Name: "John- Manager",
        ReportingPerson: "Peter-Manager"
    },
    {
        Name: "Mary-CSE ",
        ReportingPerson: "Peter-Manager"
    },];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "350px",
                layout: {
                    //Sets layout type
                    type: 'HierarchicalTree',
                    bounds: new Rect(0, 0, 500, 500),
                    horizontalSpacing: 25,
                    verticalSpacing: 30,
                    horizontalAlignment: 'Left',
                    verticalAlignment: 'Top',
                    orientation: 'BottomToTop'
                },
                dataSourceSettings: {
                    id: 'Name',
                    parentId: 'ReportingPerson',
                    dataManager: items
                },
                getNodeDefaults: (obj: Node) => {
                    obj.shape = {
                        type: 'Text',
                        content: (obj.data as {
                            Name: 'string'
                        }).Name
                    };
                    obj.style = {
                        fill: 'None',
                        strokeColor: 'none',
                        strokeWidth: 2,
                        bold: true,
                        color: 'white'
                    };
                    obj.width = 100;
                    obj.height = 40;
                    obj.borderColor = 'white';
                    obj.backgroundColor = '#6BA5D7';
                    obj.borderWidth = 1;
                    return obj;
                },
                getConnectorDefaults: (connector, diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
        provide: {
            diagram: [DataBinding, HierarchicalTree]
        },
    }
</script>
<style>
    @import "https://ej2.syncfusion.com/vue/documentation/../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Fixed node

Layout provides support to arrange the nodes with reference to the position of a fixed node and set it to the fixedNode of the layout property. This is helpful when you try to expand/collapse a node. It might be expected that the position of the double-clicked node should not be changed.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height'  :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin, HierarchicalTree, DataBinding,Diagram,Rect } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(DataBinding, HierarchicalTree);
    Vue.use(DiagramPlugin);
    let data: object[] = [{
        Name: "Steve-Ceo",
        //set the offsetX and offsetY for the parent node
        offsetX: 250,
        offsetY: 50
    },
    {
        Name: "Kevin-Manager",
        ReportingPerson: "Steve-Ceo"
    },
    {
        Name: "Peter-Manager",
        ReportingPerson: "Steve-Ceo"
    },
    {
        Name: "John- Manager",
        ReportingPerson: "Peter-Manager"
    },
    {
        Name: "Mary-CSE ",
        ReportingPerson: "Peter-Manager"
    },
    {
        Name: "Jim-CSE ",
        ReportingPerson: "Kevin-Manager"
    },
    {
        Name: "Martin-CSE",
        ReportingPerson: "Kevin-Manager"
    }];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "350px",
                layout: {
                    type: 'HierarchicalTree',
                    bounds: new Rect(0, 0, 500, 500),
                    horizontalSpacing: 25,
                    verticalSpacing: 30,
                    horizontalAlignment: 'Left',
                    verticalAlignment: 'Top'
                },
                dataSourceSettings: {
                    id: 'Name',
                    parentId: 'ReportingPerson',
                    dataManager: items
                },
                getNodeDefaults: (obj: Node) => {
                    obj.shape = {
                        type: 'Text',
                        content: (obj.data as {
                            Name: 'string'
                        }).Name
                    };
                    obj.style = {
                        fill: 'None',
                        strokeColor: 'none',
                        strokeWidth: 2,
                        bold: true,
                        color: 'white'
                    };
                    obj.width = 50;
                    obj.height = 40;
                    obj.borderColor = 'white';
                    obj.backgroundColor = '#6BA5D7';
                    obj.borderWidth = 1;
                    (obj.shape as TextModel).margin = {
                        left: 25,
                        right: 25,
                        top: 25,
                        bottom: 25
                    };
                    return obj;
                },
                getConnectorDefaults: (connector, diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
        provide: {
            diagram: [DataBinding, HierarchicalTree]
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Expand and collapse

Diagram allows to expand/collapse the subtrees of a layout. The node’s isExpanded property allows you to expand/collapse its children. The following code example shows how to expand/collapse the children of a node.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height'  :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin, HierarchicalTree, DataBinding,Diagram,Rect,NodeModel,
        Orientation,
        VerticalAlignment,
        PathElement,
        HorizontalAlignment,
        LayoutAnimation,
        SelectorConstraints,
        DiagramNativeElement,
        IconShapeModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(LayoutAnimation);
    Vue.use(DiagramPlugin);
    let data: object[] = [{
        'Id': 'parent1',
        'Name': 'Maria ',
        'Designation': 'Managing Director',
        'RatingColor': '#C34444'
    },
    {
        'Id': 'parent',
        'Name': ' sam',
        'Designation': 'Managing Director',
        'ReportingPerson': 'parent1',
        'RatingColor': '#C34444'
    },
    {
        'Id': 'parent3',
        'Name': ' sam geo',
        'Designation': 'Managing Director',
        'ReportingPerson': 'parent1',
        'RatingColor': '#C34444'
    },
    {
        'Id': '80',
        'Name': ' david',
        'Designation': 'Managing Director',
        'ReportingPerson': 'parent3',
        'RatingColor': '#C34444'
    },
    {
        'Id': '82',
        'Name': ' pirlo',
        'Designation': 'Managing Director',
        'ReportingPerson': 'parent',
        'RatingColor': '#C34444'
    }];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "350px",
                selectedItems: {
                    constraints: ~SelectorConstraints.ResizeAll
                },
                snapSettings: {
                    constraints: 0
                },
                layout: {
                    // set enableAnimation as true
                    enableAnimation: true,
                    type: 'OrganizationalChart',
                    margin: {
                        top: 20
                    }, // define the getLayoutInfo
                    getLayoutInfo: (node: Node, tree: TreeInfo) => {
                        if (!tree.hasSubTree) {
                            tree.orientation = 'vertical';
                            tree.type = 'alternate';
                        }
                    }
                }, // define the dataSourceSettings
                dataSourceSettings: {
                    id: 'Id',
                    parentId: 'ReportingPerson',
                    dataManager: items
                },
                // define the node defaults
                getNodeDefaults: (obj: Node, diagram: Diagram) => {
                    obj.expandIcon = {
                        height: 15,
                        width: 15,
                        shape: "Plus",
                        fill: 'lightgray',
                        offset: {
                            x: .5,
                            y: .85
                        }
                    }
                    obj.collapseIcon.offset = {
                        x: .5,
                        y: .85
                    }
                    obj.collapseIcon.height = 15;
                    obj.collapseIcon.width = 15;
                    obj.collapseIcon.shape = "Minus";
                    obj.height = 50;
                    obj.borderColor = 'white';
                    obj.backgroundColor = '#6BA5D7';
                    obj.borderWidth = 1;
                    obj.style = {
                        fill: 'transparent',
                        strokeWidth: 2
                    };
                    return obj;
                }, // define the connector defaults
                getConnectorDefaults: (connector: ConnectorModel, diagram: Diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.targetDecorator.shape = 'None';
                    connector.type = 'Orthogonal';
                    return connector;
                }
            }
        },
        provide: {
            diagram: [DataBinding, HierarchicalTree]
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

In the previous example, while expanding/collapsing a node, it is set as fixed node in order to prevent it from repositioning.

Refresh layout

Diagram allows to refresh the layout at runtime. To refresh the layout, refer to Refresh layout.

setNodeTemplate

The setNodeTemplate function is provided for the purpose of customizing nodes. It will be called for each node on node initialization. In this function, the node style and its properties can be customized and can bind the custom JSON with node.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height'  :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout' :dataSourceSettings='dataSourceSettings' ></ejs-diagram>
    </div>
</template>
<script>
    import Vue from 'vue';
    import { DiagramPlugin, HierarchicalTree, DataBinding,Diagram,Rect,NodeModel,
        Orientation,
        VerticalAlignment,
        PathElement,
        HorizontalAlignment,
        LayoutAnimation
        DiagramNativeElement,
        IconShapeModel } from '@syncfusion/ej2-vue-diagrams';
    import { DataManager,Query } from "@syncfusion/ej2-data";
    Diagram.Inject(LayoutAnimation);
    Vue.use(DiagramPlugin);
    let data: object[] = [{
        Name: "Steve-Ceo"
    },
    {
        Name: "Kevin-Manager",
        ReportingPerson: "Steve-Ceo",
        color: 'darkcyan'
    },
    {
        Name: "Peter-Manager",
        ReportingPerson: "Steve-Ceo",
        color: 'white'
    },
    {
        Name: "John- Manager",
        ReportingPerson: "Peter-Manager",
        color: 'darkcyan'
    },
    {
        Name: "Mary-CSE ",
        ReportingPerson: "Peter-Manager",
        color: 'white'
    },
    {
        Name: "Jim-CSE ",
        ReportingPerson: "Kevin-Manager",
        color: 'darkcyan'
    },
    {
        Name: "Martin-CSE",
        ReportingPerson: "Kevin-Manager",
        color: 'white'
    }];
    let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
    export default {
        name: 'app',
        data() {
            return {
                width: "100%",
                height: "350px",
                layout: {
                    type: 'HierarchicalTree',
                    bounds: new Rect(0, 0, 500, 500),
                    horizontalSpacing: 25,
                    verticalSpacing: 30,
                    horizontalAlignment: 'Left',
                    verticalAlignment: 'Top'
                },
                dataSourceSettings: {
                    id: 'Name',
                    parentId: 'ReportingPerson',
                    dataManager: items
                },
                getNodeDefaults: (obj: Node) => {
                    obj.shape = {
                        type: 'Text',
                        content: (obj.data as {
                            Name: 'string'
                        }).Name
                    };
                    obj.style = {
                        fill: 'None',
                        strokeColor: 'none',
                        strokeWidth: 2,
                        bold: true,
                        color: 'white'
                    };
                    obj.width = 50;
                    obj.height = 40;
                    obj.borderColor = 'white';
                    obj.backgroundColor = '#6BA5D7';
                    obj.borderWidth = 1;
                    (obj.shape as TextModel).margin = {
                        left: 25,
                        right: 25,
                        top: 25,
                        bottom: 25
                    };
                    return obj;
                },
                getConnectorDefaults: (connector: ConnectorModel, diagram: Diagram) => {
                    connector.style = {
                        strokeColor: '#6BA5D7',
                        strokeWidth: 2
                    };
                    connector.targetDecorator.style.fill  =  '#6BA5D7';
                    connector.targetDecorator.style.strokeColor  =  '#6BA5D7';
                    connector.targetDecorator.shape = 'None';
                    connector.type = 'Orthogonal';
                    return connector;
                },
                setNodeTemplate: function(obj, diagram) {
                    obj.style.borderColor = (obj.data as {
                        color: 'string'
                    }).color;
                }
            }
        },
        provide: {
            diagram: [DataBinding, HierarchicalTree]
        },
    }
</script>
<style>
    @import "../../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

Automatic layout in Angular Diagram component

7 Sep 202324 minutes to read

Diagram provides support to auto-arrange the nodes in the diagram area that is referred as Layout. It includes the following layout modes:

Layout modes

  • Hierarchical layout
  • Organization chart
  • Radial tree
  • Symmetric layout
  • Mind Map layout
  • Complex hierarchical tree layout

Hierarchical layout

The hierarchical tree layout arranges nodes in a tree-like structure, where the nodes in the hierarchical layout may have multiple parents. There is no need to specify the layout root. To arrange the nodes in a hierarchical structure, specify the layout type as hierarchical tree.

Note: If you want to use hierarchical tree layout in diagram, you need to inject HierarchicalTree in the diagram.

The following example shows how to arrange the nodes in a hierarchical structure.

import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, TextModel, DecoratorModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Name: "Steve-Ceo"
        },
        {
            Name: "Kevin-Manager",
            ReportingPerson: "Steve-Ceo"
        },
        {
            Name: "Peter-Manager",
            ReportingPerson: "Steve-Ceo"
        },
        {
            Name: "John- Manager",
            ReportingPerson: "Peter-Manager"
        },
        {
            Name: "Mary-CSE ",
            ReportingPerson: "Peter-Manager"
        },
        {
            Name: "Jim-CSE ",
            ReportingPerson: "Kevin-Manager"
        },
        {
            Name: "Martin-CSE",
            ReportingPerson: "Kevin-Manager"
        }
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel, diagram: Diagram): NodeModel {
        obj.shape = {
            type: 'Text',
            content: (obj.data as {Name: 'string'}).Name
        };
        obj.style = {
            fill: 'None',
            strokeColor: 'none',
            strokeWidth: 2,
            bold: true,
            color: 'white'
        };
        obj.borderColor = 'white';
        obj.width = 100;
        obj.height = 40;
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        (obj.shape as TextModel).margin = {
            left: 5,
            right: 5,
            top: 5,
            bottom: 5
        };
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill = '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor = '#6BA5D7';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
        //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //Sets layout type
            type: 'HierarchicalTree'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Name',
            parentId: 'ReportingPerson',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Radial tree layout

The radial tree layout arranges nodes on a virtual concentric circle around a root node. Sub-trees formed by the branching of child nodes are located radially around the child nodes. This arrangement result in an ever-expanding concentric arrangement with radial proximity to the root node indicating the node level in the hierarchy. The layout root property can be used to define the root node of the layout. When no root node is set, the algorithm automatically considers one of the diagram nodes as the root node.

To arrange nodes in a radial tree structure, set the type of the layout as RadialTree.

Note: If you want to use radial tree layout in diagram, you need to inject DataBinding and RadialTree in the diagram.

The following code illustrates how to arrange the nodes in a radial tree structure.

import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, DecoratorModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            "Id": 1,
            "Name": "Ana Trujillo",
            "Designation": "Project Manager",
            "RatingColor": "#68C2DE"
        },
        {
            "Id": 2,
            "Name": "Lino Rodri",
            "Designation": "Project Manager",
            "RatingColor": "#68C2DE",
            "ReportingPerson": 1
        },
        {
            "Id": 3,
            "Name": "Philip Cramer",
            "Designation": "Project Manager",
            "RatingColor": "#68C2DE",
            "ReportingPerson": 1
        },
        {
            "Id": 4,
            "Name": "Pedro Afonso",
            "Designation": "Project Manager",
            "RatingColor": "#68C2DE",
            "ReportingPerson": 1
        },
        {
            "Id": 5,
            "Name": "Anto Moreno",
            "Designation": "Project Lead",
            "RatingColor": "#93B85A",
            "ReportingPerson": 1
        },
        {
            "Id": 6,
            "Name": "Elizabeth Roel",
            "Designation": "Project Lead",
            "RatingColor": "#93B85A",
            "ReportingPerson": 1
        },
        {
            "Id": 7,
            "Name": "Aria Cruz",
            "Designation": "Project Lead",
            "RatingColor": "#93B85A",
            "ReportingPerson": 1
        },
        {
            "Id": 8,
            "Name": "Eduardo Roel",
            "Designation": "Project Lead",
            "RatingColor": "#93B85A",
            "ReportingPerson": 1
        },
        {
            "Id": 9,
            "Name": "Howard Snyd",
            "Designation": "Project Lead",
            "RatingColor": "#68C2DE",
            "ReportingPerson": 1
        },
        {
            "Id": 10,
            "Name": "Daniel Tonini",
            "Designation": "Project Lead",
            "RatingColor": "#93B85A",
            "ReportingPerson": 1
        },
        {
            "Id": 11,
            "Name": "Nardo Batista",
            "Designation": "Project Lead",
            "RatingColor": "#68C2DE",
            "ReportingPerson": 1
        }
    ];
    public getNodeDefaults(obj: NodeModel): NodeModel {
        obj.height = 15;
        obj.width = 15;
        obj.borderWidth = 1;
        obj.style = {
            fill: '#6BA5D7',
            strokeWidth: 2,
            strokeColor: '#6BA5D7'
        };
        return obj;
    }
    //Sets the default properties for and connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).shape = 'None';
        connector.type = 'Straight';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
        //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //set the type as Radial Tree
            type: 'RadialTree',
            root: 'parent'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Id',
            parentId: 'ReportingPerson',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, RadialTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [RadialTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Organizational Chart

An organizational chart is a diagram that displays the structure of an organization and relationships. To create an organizational chart, the type of layout should be set as an OrganizationalChart.

The following code example illustrates how to create an organizational chart.

import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, TextModel, DecoratorModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Id: "parent",
            Role: "Project Management"
        },
        {
            Id: 1,
            Role: "R&D Team",
            Team: "parent"
        },
        {
            Id: 3,
            Role: "Philosophy",
            Team: "1"
        },
        {
            Id: 4,
            Role: "Organization",
            Team: "1"
        },
        {
            Id: 5,
            Role: "Technology",
            Team: "1"
        },
        {
            Id: 7,
            Role: "Funding",
            Team: "1"
        },
        {
            Id: 8,
            Role: "Resource Allocation",
            Team: "1"
        },
        {
            Id: 9,
            Role: "Targeting",
            Team: "1"
        },
        {
            Id: 11,
            Role: "Evaluation",
            Team: "1"
        },
        {
            Id: 156,
            Role: "HR Team",
            Team: "parent"
        },
        {
            Id: 13,
            Role: "Recruitment",
            Team: "156"
        },
        {
            Id: 113,
            Role: "Training",
            Team: "12"
        },
        {
            Id: 112,
            Role: "Employee Relation",
            Team: "156"
        },
        {
            Id: 14,
            Role: "Record Keeping",
            Team: "12"
        },
        {
            Id: 15,
            Role: "Compensations & Benefits",
            Team: "12"
        },
        {
            Id: 16,
            Role: "Compliances",
            Team: "12"
        },
        {
            Id: 17,
            Role: "Production & Sales Team",
            Team: "parent"
        },
        {
            Id: 119,
            Role: "Design",
            Team: "17"
        },
        {
            Id: 19,
            Role: "Operation",
            Team: "17"
        },
        {
            Id: 20,
            Role: "Support",
            Team: "17"
        },
        {
            Id: 21,
            Role: "Quality Assurance",
            Team: "17"
        },
        {
            Id: 23,
            Role: "Customer Interaction",
            Team: "17"
        },
        {
            Id: 24,
            Role: "Support and Maintenance",
            Team: "17"
        },
        {
            Id: 25,
            Role: "Task Coordination",
            Team: "17"
        }
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel, diagram: Diagram): NodeModel {
        obj.shape = {
            type: 'Text',
            content: (obj.data as {
                Role: 'string'
            }).Role
        };
        obj.style = {
            fill: 'None',
            strokeColor: 'none',
            strokeWidth: 2,
            bold: true,
            color: 'white'
        };
        obj.borderColor = 'white';
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        obj.width = 75;
        obj.height = 40;
        (obj.shape as TextModel).margin = {
            left: 5,
            right: 5,
            top: 5,
            bottom: 5
        };
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(5));
        //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //set the type as Organizational Chart
            type: 'OrganizationalChart'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Id',
            parentId: 'Team',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Organizational chart layout starts parsing from root and iterate through all its child elements. The getLayoutInfo method provides necessary information of a node’s children and the way to arrange (direction, orientation, offsets, etc.) them. The arrangements can be customized by overriding this function as explained.

GetLayoutInfo - Set chart orientations, chart types, and offset to be left between parent and child nodes by overriding the method, diagram.layout.getLayoutInfo. The getLayoutInfo method is called to configure every subtree of the organizational chart. It takes the following arguments.

  • node - Parent node to that options are to be customized.
  • options - Object to set the customizable properties.
import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, DecoratorModel, ShapeStyleModel, TreeInfo } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Id: 1,
            Role: "General Manager"
        },
        {
            Id: 2,
            Role: "Assistant Manager",
            Team: 1
        },
        {
            Id: 3,
            Role: "Human Resource Manager",
            Team: 1
        },
        {
            Id: 4,
            Role: "Design Manager",
            Team: 1
        },
        {
            Id: 5,
            Role: "Operation Manager",
            Team: 1
        },
        {
            Id: 6,
            Role: "Marketing Manager",
            Team: 1
        }
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel | any, diagram: Diagram): NodeModel {
        obj.width = 150;
        obj.height = 50;
        obj.style.fill = '#6BA5D7';
        obj.annotations = [{
            content: obj.data['Role'],
            style: {
                color: 'white'
            }
        }];
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).shape = 'None';
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).shape = 'None';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
        //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //Sets layout type
            type: 'OrganizationalChart',
            getLayoutInfo: (node: Node, options: TreeInfo) => {
                if (!options.hasSubTree) {
                    options.type = 'Center';
                    options.orientation = 'Horizontal';
                }
            }
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Id',
            parentId: 'Team',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

The following table illustrates the properties that “options” argument takes.

Property Description Default Value
options.assistants By default, the collection is empty. When any of the child nodes have to be set as Assistant, you can remove from children collection and have to insert into assistants collection. Empty array
options.orientation Gets or sets the organizational chart orientation. SubTreeOrientation.Vertical
options.type Gets or sets the chart organizational chart type. For horizontal chart orientation:SubTreeAlignments.Center and for vertical chart orientation:SubTreeAlignments.Alternate
options.offset Offset is the horizontal space to be left between parent and child nodes. 20 pixels applicable only for vertical chart orientations.
options.hasSubTree Gets whether the node contains subtrees. Boolean
options.level Gets the depth of the node from layout root. Number
options.enableRouting By default, connections are routed based on the chart type and orientations. This property gets or sets whether default routing is to be enabled or disabled. true
options.rows Sets the number of rows on which the child nodes will be arranged. Applicable only for balanced type horizontal tree. Number

The following table illustrates the different chart orientations and chart types.

Orientation Type Description Example
Horizontal Left Arranges the child nodes horizontally at the left side of the parent. Horizontal Left
  Right Arranges the child nodes horizontally at the right side of the parent. Horizontal Right
  Center Arranges the children like standard tree layout orientation. Horizontal Center
  Balanced Arranges the leaf level child nodes in multiple rows. Horizontal Balanced
Vertical Left Arranges the children vertically at the left side of the parent. Vertical Left
  Right Arranges the children vertically at the right side of the parent. Vertical Right
  Alternate Arranges the children vertically at both left and right sides of the parent. Vertical Alternate

The following code example illustrates how to set the vertical right arrangement to the leaf level trees.

import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, DecoratorModel, ShapeStyleModel, TreeInfo } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Id: "parent",
            Role: "Board"
        },
        {
            Id: "1",
            Role: "General Manager",
            Manager: "parent"
        },
        {
            Id: "2",
            Role: "Human Resource Manager",
            Manager: "1"
        },
        {
            Id: "3",
            Role: "Trainers",
            Manager: "2"
        },
        {
            Id: "4",
            Role: "Recruiting Team",
            Manager: "2"
        },
        {
            Id: "6",
            Role: "Design Manager",
            Manager: "1"
        },
        {
            Id: "7",
            Role: "Design Supervisor",
            Manager: "6"
        },
        {
            Id: "8",
            Role: "Development Supervisor",
            Manager: "6"
        },
        {
            Id: "9",
            Role: "Drafting Supervisor",
            Manager: "6"
        },
        {
            Id: "10",
            Role: "Marketing Manager",
            Manager: "1"
        },
        {
            Id: "11",
            Role: "Oversea sales Manager",
            Manager: "10"
        },
        {
            Id: "12",
            Role: "Petroleum Manager",
            Manager: "10"
        },
        {
            Id: "13",
            Role: "Service Dept. Manager",
            Manager: "10"
        },
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel | any, diagram: Diagram): NodeModel {
        obj.width = 150;
        obj.height = 50;
        obj.borderColor = 'white';
        obj.style.fill = '#6BA5D7';
        obj.borderWidth = 1;
        obj.annotations = [{
            content: obj.data['Role'],
            style: {
                color: 'white'
            }
        }];
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill = '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor = '#6BA5D7';
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).shape = 'None';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
        //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
        //Sets layout type
        type: 'OrganizationalChart',
        //Defines getLayoutInfo
        getLayoutInfo: (node: Node | any, options: TreeInfo) => {
            if (node.data['Role'] === 'General Manager') {
                ((options as TreeInfo).assistants as string[]).push(((options as TreeInfo).children as string[])[0]);
                ((options as TreeInfo).children as string[]).splice(0, 1);
            }
            if (!options.hasSubTree) {
                options.type = 'Right';
                options.orientation = 'Vertical';
            }
        }
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Id',
            parentId: 'Manager',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Assistant

Assistants are child item that have a different relationship with the parent node. They are laid out in a dedicated part of the tree. A node can be specified as an assistant of its parent by adding it to the assistants property of the argument “options”.

The following code example illustrates how to add assistants to layout.

import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, DecoratorModel, ShapeStyleModel, TreeInfo } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Id: 1,
            Role: "General Manager"
        },
        {
            Id: 2,
            Role: "Assistant Manager",
            Team: 1
        },
        {
            Id: 3,
            Role: "Human Resource Manager",
            Team: 1
        },
        {
            Id: 4,
            Role: "Design Manager",
            Team: 1
        },
        {
            Id: 5,
            Role: "Operation Manager",
            Team: 1
        },
        {
            Id: 6,
            Role: "Marketing Manager",
            Team: 1
        }
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel | any, diagram: Diagram): NodeModel {
        obj.width = 150;
        obj.height = 50;
        obj.borderColor = 'white';
        obj.style.fill = '#6BA5D7';
        obj.borderWidth = 1;
        obj.annotations = [{
            content: obj.data['Role'],
            style: {
                color: 'white'
            }
        }];
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).shape = 'None';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
        //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //Sets layout type
            type: 'OrganizationalChart',
            // define the getLayoutInfo
            getLayoutInfo: (node: Node | any, options: TreeInfo) => {
                if (node.data['Role'] === 'General Manager') {
                    ((options as TreeInfo).assistants as string[]).push(((options as TreeInfo).children as string[])[0]);
                    ((options as TreeInfo).children as string[]).splice(0, 1);
                }
                if (!options.hasSubTree) {
                    (options as TreeInfo).type = 'Center';
                    (options as TreeInfo).orientation = 'Horizontal';
                }
            }
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Id',
            parentId: 'Team',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Symmetric layout

The symmetric layout has been formed using nodes position by closer together or pushing them further apart. This is repeated iteratively until the system comes to an equilibrium state.

The layout’s springLength defined as how long edges should be, ideally. This will be the resting length for the springs. Edge attraction and vertex repulsion forces to be defined by using layout’s springFactor, the more sibling nodes repel each other. The relative positions do not change any more from one iteration to the next. The number of iterations can be specified by using layout’s maxIteration.

Note: If you want to use symmetric layout in diagram, you need to inject SymmetricLayout in the diagram.

Mind Map layout

A mind map is a diagram that displays the nodes as a spider diagram organizes information around a central concept. To create mind map, the type of layout should be set as MindMap.

To create a Mindmap Layout using Angular Diagram, refer to the below video link,

Tree Orientation in layout

An Orientation of a MindMapTreeLayout is used to arrange the tree layout according to a specific direction. By default, the orientation is set to Horizontal. The following table outlines the various orientation types available:

</table> >Note: If you want to use mind map layout in diagram, you need to inject MindMap in the diagram. The following code example illustrates how to create an mindmap layout
import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DataBinding,Diagram,HierarchicalTree, NodeModel, ConnectorModel, MindMap,SnapSettingsModel, LayoutModel, DataSourceModel, TextModel, DecoratorModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';
Diagram.Inject( MindMap );

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            id: 1,
            Label: 'StackPanel'
        },
        {
            id: 2,
            Label: 'Label',
            parentId: 1
        },
        {
            id: 3,
            Label: 'ListBox',
            parentId: 1
        },
        {
            id: 4,
            Label: 'StackPanel',
            parentId: 2
        },
        {
            id: 5,
            Label: 'Border',
            parentId: 2
        },
        {
            id: 6,
            Label: 'Border',
            parentId: 4
        },
        {
            id: 7,
            Label: 'Button',
            parentId: 4
        },
        {
            id: 8,
            Label: 'ContentPresenter',
            parentId: 5
        },
        {
            id: 9,
            Label: 'Text Block',
            parentId: 5
        },
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel, diagram: Diagram): NodeModel {
        obj.shape = {
            type: 'Text',
            content: (obj.data as {
                Label: 'string'
            }).Label,
        };
        obj.style = {
            fill: '#6BA5D7',
            strokeColor: 'none',
            strokeWidth: 2
        };
        obj.borderColor = 'white';
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        (obj.shape as TextModel).margin = {
            left: 5,
            right: 5,
            top: 5,
            bottom: 5
        };
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).shape = 'None';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
        //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //Sets layout type
            type: 'MindMap',
            orientation: 'Horizontal'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'id',
            parentId: 'parentId',
            dataSource: this.items,
            root: String(1)
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, MindMapService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [MindMapService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
## Complex hierarchical tree Complex hierarchical tree layout is the extended version of the hierarchical tree layout. The child had been two or more parents. To create a complex hierarchical tree, the [`type`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout) of layout should be set as `ComplexHierarchicalTree`. The following code example illustrates how to create a complex hierarchical tree.
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DecoratorModel, DiagramComponent, StrokeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import {
    NodeModel, ConnectorModel, DiagramTools, Diagram, DataBinding, ComplexHierarchicalTree,
    SnapConstraints, SnapSettingsModel, LayoutModel, LayoutOrientation
} from '@syncfusion/ej2-diagrams';
import { DataManager } from '@syncfusion/ej2-data';
import { ChangeEventArgs as NumericChangeEventArgs } from '@syncfusion/ej2-inputs';
Diagram.Inject(DataBinding, ComplexHierarchicalTree);

export interface DataInfo {
    [key: string]: string;
}

/**
 * Sample for Multiple parent sample
 */
@Component({
    selector: 'app-container',
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getConnectorDefaults]='connDefaults'
    [getNodeDefaults]='nodeDefaults' [tool]='tool' [layout]='layout' [dataSourceSettings]='data' [snapSettings]='snapSettings'
    (created)="created()"></ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    @ViewChild('diagram')
    public diagram?: DiagramComponent;

    public nodeDefaults(obj: NodeModel): NodeModel {
        obj.width = 40; obj.height = 40;
        //Initialize shape
        obj.shape = { type: 'Basic', shape: 'Rectangle', cornerRadius: 7 };
        return obj;
    };
    public data: Object = {
        id: 'Name', parentId: 'ReportingPerson',
        dataSource: new DataManager([
            {"Name": "node11","fillColor": "#e7704c","border": "#c15433"},
            {"Name": "node12","ReportingPerson": ["node114"],"fillColor": "#efd46e","border": "#d6b123"},
            {"Name": "node13","ReportingPerson": ["node12"],"fillColor": "#58b087","border": "#16955e"},
            {"Name": "node14","ReportingPerson": ["node12"],"fillColor": "#58b087","border": "#16955e"},
            {"Name": "node15","ReportingPerson": ["node12"],"fillColor": "#58b087","border": "#16955e"},
            {"Name": "node16","ReportingPerson": [],"fillColor": "#14ad85"},
            {"Name": "node17","ReportingPerson": ["node13","node14","node15"],"fillColor": "#659be5","border": "#3a6eb5"},
            {"Name": "node18","ReportingPerson": [],"fillColor": "#14ad85"},
            {"Name": "node19","ReportingPerson": ["node16","node17","node18"],"fillColor": "#8dbe6c","border": "#489911"},
            {"Name": "node110","ReportingPerson": ["node16","node17","node18"],"fillColor": "#8dbe6c","border": "#489911"},
            {"Name": "node111","ReportingPerson": ["node16","node17","node18","node116"],"fillColor": "#8dbe6c","border": "#489911"},
            {"Name": "node21","fillColor": "#e7704c","border": "#c15433"},
            {"Name": "node22","ReportingPerson": ["node114"],"fillColor": "#efd46e","border": "#d6b123"},
            {"Name": "node23","ReportingPerson": ["node22"],"fillColor": "#58b087","border": "#16955e"},
            {"Name": "node24","ReportingPerson": ["node22"],"fillColor": "#58b087","border": "#16955e"},
            {"Name": "node25","ReportingPerson": ["node22"],"fillColor": "#58b087","border": "#16955e"},
            {"Name": "node26","ReportingPerson": [],"fillColor": "#14ad85"},
            {"Name": "node27","ReportingPerson": ["node23","node24","node25"],"fillColor": "#659be5","border": "#3a6eb5"},
            {"Name": "node28","ReportingPerson": [],"fillColor": "#14ad85"},
            {"Name": "node29","ReportingPerson": ["node26","node27","node28","node116"],"fillColor": "#8dbe6c","border": "#489911"},
            {"Name": "node210","ReportingPerson": ["node26","node27","node28"],"fillColor": "#8dbe6c","border": "#489911"},
            {"Name": "node211","ReportingPerson": ["node26","node27","node28"],"fillColor": "#8dbe6c","border": "#489911"},
            {"Name": "node31","fillColor": "#e7704c","border": "#c15433"},
            {"Name": "node114","ReportingPerson": ["node11","node21","node31"],"fillColor": "#f3904a","border": "#d3722e"},
            {"Name": "node116","ReportingPerson": ["node12","node22"],"fillColor": "#58b087","border": "#16955e"}
        ],),
        //binds the external data with node
        doBinding: (nodeModel: NodeModel, data: DataInfo, diagram: Diagram) => {
            /* tslint:disable:no-string-literal */
            nodeModel.style = { fill: data['fillColor'], strokeWidth: 1, strokeColor: data['border'] };
        }
    };
    public created(): void {
        (this.diagram as DiagramComponent).fitToPage();
    };
    public connDefaults(connector: ConnectorModel): void {
        connector.type = 'Orthogonal';
        connector.cornerRadius = 7;
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).height = 7;
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).width = 7;
        ((connector as ConnectorModel).style as StrokeStyleModel).strokeColor = '#6d6d6d';
    };

    public tool: DiagramTools = DiagramTools.ZoomPan;

    public snapSettings: SnapSettingsModel = { constraints: SnapConstraints.None };

    public layout: LayoutModel = {
        type: 'ComplexHierarchicalTree',
        horizontalSpacing: 40, verticalSpacing: 40, orientation: 'TopToBottom',
        margin: { left: 10, right: 0, top: 50, bottom: 0 }
    };
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
>Note: If you want to use Complex hierarchical layout in diagram, you need to inject ComplexHierarchicalTree in the diagram. ### Line Distribution Line distribution is used to arrange the connectors without overlapping in automatic layout. In some cases, the automatic layout connectors connecting to the nodes will be overlapped with one another. So user can decide whether the segment of each connector from a single parent node should be same point or different point. The [`connectionPointOrigin`](https://ej2.syncfusion.com/angular/documentation/api/diagram/connectionPointOrigin/#connectionpointorigin) property of layout is used to enable or disable the line distribution in layout. By default connectionPointOrigin will be `SamePoint`. The following code example illustrates how to create a complex hierarchical tree with line distribution. >Note: If you want to use line distribution in diagram layout, you need to inject LineDistribution module in the diagram.
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DecoratorModel, DiagramComponent, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import {
    NodeModel, ConnectorModel, Diagram, DataBinding, ComplexHierarchicalTree,
    SnapConstraints, SnapSettingsModel, LayoutModel, LayoutOrientation, LineDistribution, ConnectionPointOrigin
} from '@syncfusion/ej2-diagrams';
import { DataManager } from '@syncfusion/ej2-data';
Diagram.Inject(DataBinding, ComplexHierarchicalTree, LineDistribution);

@Component({
    selector: 'app-container',
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="590px" [getConnectorDefaults]='connDefaults'
    [getNodeDefaults]='nodeDefaults' [layout]='layout' [dataSourceSettings]='data' [snapSettings]='snapSettings'
    (created)="created()"></ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    @ViewChild('diagram')
    public diagram?: DiagramComponent;

    public nodeDefaults(obj: NodeModel): NodeModel {
        obj.width = 40; obj.height = 40;
        obj.shape = { type: 'Basic', shape: 'Rectangle' };
        obj.style = { fill: '#6BA5D7', strokeColor: 'none', strokeWidth: 2 };
        obj.borderWidth = 1;
        obj.backgroundColor = '#6BA5D7';
        return obj;
    };
    public data: Object = {
        id: 'Name', parentId: 'ReportingPerson',
        dataSource: new DataManager([
            { "Name": "node11" },
            { "Name": "node12", "ReportingPerson": ["node114"] },
            { "Name": "node13", "ReportingPerson": ["node12"] },
            { "Name": "node14", "ReportingPerson": ["node12"] },
            { "Name": "node15", "ReportingPerson": ["node12"] },
            { "Name": "node116", "ReportingPerson": ["node22","node12"] },
            { "Name": "node16", "ReportingPerson": [] },
            { "Name": "node18", "ReportingPerson": [] },
            { "Name": "node21" },
            { "Name": "node22", "ReportingPerson": ["node114"] },
            { "Name": "node23", "ReportingPerson": ["node22"] },
            { "Name": "node24", "ReportingPerson": ["node22"] },
            { "Name": "node25", "ReportingPerson": ["node22"] },
            { "Name": "node26", "ReportingPerson": [] },
            { "Name": "node28", "ReportingPerson": [] },
            { "Name": "node31" },
            { "Name": "node114", "ReportingPerson": ["node11", "node21", "node31"]}
        ],),
    };
    public created(): void {
        (this.diagram as DiagramComponent).fitToPage();
    };
    public connDefaults(connector: ConnectorModel) {
        connector.type = 'Orthogonal';
        connector.cornerRadius = 7;
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).height = 7;
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).width = 7;
        connector.style = { strokeColor: '#6BA5D7', strokeWidth: 1 };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        return connector;
    };
    public snapSettings: SnapSettingsModel = { constraints: SnapConstraints.None };
    public layout: LayoutModel = {
        type: 'ComplexHierarchicalTree',
        connectionPointOrigin: ConnectionPointOrigin.DifferentPoint,
        horizontalSpacing: 40, verticalSpacing: 40, horizontalAlignment: "Left", verticalAlignment: "Top",
        margin: { left: 0, right: 0, top: 0, bottom: 0 },
        orientation: 'TopToBottom'
    };
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, ComplexHierarchicalTreeService, DataBindingService, LineDistributionService, LayoutAnimationService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [ComplexHierarchicalTreeService, DataBindingService, LineDistributionService, LayoutAnimationService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
### Linear Arrangement Linear arrangement is used to linearly arrange the child nodes in layout, which means the parent node is placed in the center corresponding to its children. When line distribution is enabled, linear arrangement is also activated by default. The [`arrangement`](https://ej2.syncfusion.com/angular/documentation/api/diagram/childArrangement/#childarrangement) property of layout is used to enable or disable the linear arrangement in layout. By default arrangement will be `Nonlinear`. >Note: If you want to use linear arrangement in diagram layout, you need to inject LineDistribution module in the diagram. Linear arrangement is applicable only for complex hierarchical tree layout. The following code illustrates how to allow a linear arrangement in diagram layout. ```typescript @Component({ selector: "app-container", template: `<ejs-diagram id="diagram" width="100%" height="580px" [layout]='layout'></ejs-diagram>`, encapsulation: ViewEncapsulation.None }) export class AppComponent { public layout: LayoutModel = { type: 'ComplexHierarchicalTree', //To arrange the child nodes in a linear manner arrangement: ChildArrangement.Linear, horizontalSpacing: 40, verticalSpacing: 40, orientation: 'TopToBottom', }; } ``` ### Prevent connectors overlay The below constraints prevents the connector segments overlapping nodes with a complex hierarchical layout. ```typescript @Component({ selector: "app-container", template: `<ejs-diagram id="diagram" width="100%" height="580px" [layout]='layout'></ejs-diagram>`, encapsulation: ViewEncapsulation.None }) export class AppComponent { public layout: LayoutModel = { //this prevents connector segments overlapping enableRouting: true, }; } ``` ## Customize layout Orientation, spacings, and position of the layout can be customized with a set of properties. To explore layout properties, refer to [`Layout Properties`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout). ### Layout bounds Diagram provides support to align the layout within any custom rectangular area. For more information about bounds, refer to [`bounds`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout). ### Layout alignment The layout can be aligned anywhere over the layout bounds/viewport using the [`horizontalAlignment`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout) and [`verticalAlignment`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout) properties of the layout. The following code illustrates how to align the layout at the top-left of the layout bounds.
import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, DecoratorModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Name: "Steve-Ceo"
        },
        {
            Name: "Kevin-Manager",
            ReportingPerson: "Steve-Ceo"
        },
        {
            Name: "Peter-Manager",
            ReportingPerson: "Kevin-Manager"
        },
        {
            Name: "John- Manager",
            ReportingPerson: "Peter-Manager"
        },
        {
            Name: "Mary-CSE ",
            ReportingPerson: "Peter-Manager"
        },
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel, diagram: Diagram): NodeModel {
        obj.shape = {
            type: 'Text',
            content: (obj.data as {
                Name: 'string'
            }).Name
        };
        obj.style = {
            fill: 'None',
            strokeColor: 'none',
            strokeWidth: 2,
            bold: true,
            color: 'white'
        };
        obj.width = 100;
        obj.height = 40;
        obj.borderColor = 'white';
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
            //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //Sets layout type
            type: 'HierarchicalTree',
            //set layout alignment
            //bounds: new Rect(0, 0, 500, 500),
            horizontalSpacing: 25,
            verticalSpacing: 30,
            horizontalAlignment: 'Left',
            verticalAlignment: 'Top'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Name',
            parentId: 'ReportingPerson',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
### Layout spacing Layout provides support to add space horizontally and vertically between the nodes. The [`horizontalSpacing`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout) and [`verticalSpacing`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout) properties of the layout allows you to set the space between the nodes in horizontally and vertically. ### Layout margin Layout provides support to add some blank space between the layout bounds/viewport and the layout. The [`margin`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout) property of the layout allows you to set the blank space. The following code illustrates how to set the layout margin.
import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, DecoratorModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Name: "Steve-Ceo"
        },
        {
            Name: "Kevin-Manager",
            ReportingPerson: "Steve-Ceo"
        },
        {
            Name: "Peter-Manager",
            ReportingPerson: "Kevin-Manager"
        },
        {
            Name: "John- Manager",
            ReportingPerson: "Peter-Manager"
        },
        {
            Name: "Mary-CSE ",
            ReportingPerson: "Peter-Manager"
        },
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel, diagram: Diagram): NodeModel {
        obj.shape = {
            type: 'Text',
            content: (obj.data as {
                Name: 'string'
            }).Name
        };
        obj.style = {
            fill: 'None',
            strokeColor: 'none',
            strokeWidth: 2,
            bold: true,
            color: 'white'
        };
        obj.width = 100;
        obj.height = 40;
        obj.borderColor = 'white';
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
            //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //Sets layout type
            type: 'HierarchicalTree',
            //bounds: new Rect(0, 0, 500, 500),
            horizontalSpacing: 25,
            verticalSpacing: 30,
            horizontalAlignment: 'Left',
            verticalAlignment: 'Top'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Name',
            parentId: 'ReportingPerson',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
### Layout orientation The layout orientation can used to arrange the layout based on the direction. there are different orientation types that are defined in the following table. |Orientation|Description| | -------- | ----------- | |TopToBottom|Aligns the layout from top to bottom. All the roots are placed at top of diagram.| |LeftToRight|Aligns the layout from left to right. All the roots are placed at left of diagram.| |BottomToTop|Aligns the layout from bottom to top. All the roots are placed at bottom of the diagram.| |RightToLeft|Aligns the layout from right to left. All the roots are placed at right of the diagram.| Diagram provides support to customize the [`orientation`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout) of layout. You can set the desired orientation using layout.orientation. >Note: In the diagram the default orientation is TopToBottom. The following code illustrates how to arrange the nodes in a BottomToTop orientation.
import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, DecoratorModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Name: "Steve-Ceo"
        },
        {
            Name: "Kevin-Manager",
            ReportingPerson: "Steve-Ceo"
        },
        {
            Name: "Peter-Manager",
            ReportingPerson: "Kevin-Manager"
        },
        {
            Name: "John- Manager",
            ReportingPerson: "Peter-Manager"
        },
        {
            Name: "Mary-CSE ",
            ReportingPerson: "Peter-Manager"
        },
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel, diagram: Diagram): NodeModel {
        obj.shape = {
            type: 'Text',
            content: (obj.data as {
                Name: 'string'
            }).Name
        };
        obj.style = {
            fill: 'None',
            strokeColor: 'none',
            strokeWidth: 2,
            bold: true,
            color: 'white'
        };
        obj.width = 100;
        obj.height = 40;
        obj.borderColor = 'white';
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
            //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //Sets layout type
            type: 'HierarchicalTree',
            //bounds: new Rect(0, 0, 500, 500),
            horizontalSpacing: 25,
            verticalSpacing: 30,
            horizontalAlignment: 'Left',
            verticalAlignment: 'Top',
            orientation: 'BottomToTop'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Name',
            parentId: 'ReportingPerson',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
### Fixed node Layout provides support to arrange the nodes with reference to the position of a fixed node and set it to the [`fixedNode`](https://ej2.syncfusion.com/angular/documentation/api/diagram/layout) of the layout property. This is helpful when you try to expand/collapse a node. It might be expected that the position of the double-clicked node should not be changed.
import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, DecoratorModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Name: "Steve-Ceo",
            //set the offsetX and offsetY for the parent node
            offsetX: 250,
            offsetY: 50
        },
        {
            Name: "Kevin-Manager",
            ReportingPerson: "Steve-Ceo"
        },
        {
            Name: "Peter-Manager",
            ReportingPerson: "Steve-Ceo"
        },
        {
            Name: "John- Manager",
            ReportingPerson: "Peter-Manager"
        },
        {
            Name: "Mary-CSE ",
            ReportingPerson: "Peter-Manager"
        },
        {
            Name: "Jim-CSE ",
            ReportingPerson: "Kevin-Manager"
        },
        {
            Name: "Martin-CSE",
            ReportingPerson: "Kevin-Manager"
        }
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel, diagram: Diagram): NodeModel {
        obj.shape = {
            type: 'Text',
            content: (obj.data as {
                Name: 'string'
            }).Name
        };
        obj.style = {
            fill: 'None',
            strokeColor: 'none',
            strokeWidth: 2,
            bold: true,
            color: 'white'
        };
        obj.width = 100;
        obj.height = 40;
        obj.borderColor = 'white';
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
            //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            type: 'HierarchicalTree',
            //bounds: new Rect(0, 0, 500, 500),
            horizontalSpacing: 25,
            verticalSpacing: 30,
            horizontalAlignment: 'Left',
            verticalAlignment: 'Top'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Name',
            parentId: 'ReportingPerson',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
### Expand and collapse Diagram allows to expand/collapse the subtrees of a layout. The node’s isExpanded property allows you to expand/collapse its children. The following code example shows how to expand/collapse the children of a node.
import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SelectorModel, SelectorConstraints, SnapSettingsModel, LayoutModel, DataSourceModel, DecoratorModel, ShapeStyleModel, TreeInfo } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [selectedItems]="selectedItems" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public selectedItems?: SelectorModel;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            'Id': 'parent1',
            'Name': 'Maria ',
            'Designation': 'Managing Director',
            'RatingColor': '#C34444'
        },
        {
            'Id': 'parent',
            'Name': ' sam',
            'Designation': 'Managing Director',
            'ReportingPerson': 'parent1',
            'RatingColor': '#C34444'
        },
        {
            'Id': 'parent3',
            'Name': ' sam geo',
            'Designation': 'Managing Director',
            'ReportingPerson': 'parent1',
            'RatingColor': '#C34444'
        },
        {
            'Id': '80',
            'Name': ' david',
            'Designation': 'Managing Director',
            'ReportingPerson': 'parent3',
            'RatingColor': '#C34444'
        },
        {
            'Id': '82',
            'Name': ' pirlo',
            'Designation': 'Managing Director',
            'ReportingPerson': 'parent',
            'RatingColor': '#C34444'
        }
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel | any, diagram: Diagram): NodeModel {
        obj.expandIcon = {
            height: 15,
            width: 15,
            shape: "Plus",
            fill: 'lightgray',
            offset: {
                x: .5,
                y: .85
            }
        };
        obj.collapseIcon.offset = {
            x: .5,
            y: .85
        };
        obj.collapseIcon.height = 15;
        obj.collapseIcon.width = 15;
        obj.collapseIcon.shape = "Minus";
        obj.height = 50;
        obj.borderColor = 'white';
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        obj.style = {
            fill: 'transparent',
            strokeWidth: 2
        };
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).shape = 'None';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.selectedItems = {
            constraints: ~SelectorConstraints.ResizeAll
        }
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
            //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            // set enableAnimation as true
            enableAnimation: true,
            type: 'OrganizationalChart',
            margin: {
                top: 20
            },// define the getLayoutInfo
            getLayoutInfo: (node: Node, tree: TreeInfo | any) => {
                if (!tree.hasSubTree) {
                    tree.orientation = 'vertical';
                    tree.type = 'alternate';
                }
            }
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Id',
            parentId: 'ReportingPerson',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService, LayoutAnimationService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService, LayoutAnimationService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
In the previous example, while expanding/collapsing a node, it is set as fixed node in order to prevent it from repositioning. ### Refresh layout Diagram allows to refresh the layout at runtime. To refresh the layout, refer to [`Refresh layout`](https://ej2.syncfusion.com/angular/documentation/api/diagram/#dolayout). ### setNodeTemplate The [`setNodeTemplate`](https://ej2.syncfusion.com/angular/documentation/api/diagram/#setnodetemplate) function is provided for the purpose of customizing nodes. It will be called for each node on node initialization. In this function, the node style and its properties can be customized and can bind the custom JSON with node.
import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, TextModel, DecoratorModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings" [setNodeTemplate]="setNodeTemplate">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Name: "Steve-Ceo"
        },
        {
            Name: "Kevin-Manager",
            ReportingPerson: "Steve-Ceo"
        },
        {
            Name: "Peter-Manager",
            ReportingPerson: "Kevin-Manager"
        },
        {
            Name: "John- Manager",
            ReportingPerson: "Peter-Manager"
        },
        {
            Name: "Mary-CSE ",
            ReportingPerson: "Peter-Manager"
        },
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel, diagram: Diagram): NodeModel {
        obj.shape = {
            type: 'Text',
            content: (obj.data as {
                Name: 'string'
            }).Name
        };
        obj.style = {
            fill: 'None',
            strokeColor: 'none',
            strokeWidth: 2,
            bold: true,
            color: 'white'
        };
        obj.width = 50;
        obj.height = 40;
        obj.borderColor = 'white';
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        (obj.shape as TextModel).margin = {
            left: 25,
            right: 25,
            top: 25,
            bottom: 25
        };
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill  =  '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor  =  '#6BA5D7';
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).shape = 'None';
        connector.type = 'Orthogonal';
        return connector;
    }
    public setNodeTemplate(obj: any): void {
        obj.style.borderColor = (obj.data as {
            color: 'string'
        }).color;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(7));
            //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            type: 'HierarchicalTree',
            //bounds: new Rect(0, 0, 500, 500),
            horizontalSpacing: 25,
            verticalSpacing: 30,
            horizontalAlignment: 'Left',
            verticalAlignment: 'Top'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Name',
            parentId: 'ReportingPerson',
            dataSource: this.items
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, DiagramModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [HierarchicalTreeService, DataBindingService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
Orientation Type</td> Description</td> </tr>
Horizontal Aligns the tree layout from left to right
Vertical Aligns the tree layout from top to bottom